/* "@(#)maptool.c Aug  2 22:56:11 2014" */
/* Generated by XDS Modula-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef maptool_H_
#include "maptool.h"
#endif
#define maptool_C_
#ifndef aprspos_H_
#include "aprspos.h"
#endif
#ifndef aprsdecode_H_
#include "aprsdecode.h"
#endif
#ifndef xosi_H_
#include "xosi.h"
#endif
#ifndef osi_H_
#include "osi.h"
#endif
#include <math.h>
#ifndef InOut_H_
#include "InOut.h"
#endif
#ifndef FileSys_H_
#include "FileSys.h"
#endif
#ifndef aprsstr_H_
#include "aprsstr.h"
#endif
#ifndef pngread_H_
#include "pngread.h"
#endif
#ifndef pngwrite_H_
#include "pngwrite.h"
#endif
#ifndef jpgdec_H_
#include "jpgdec.h"
#endif
#ifndef TimeConv_H_
#include "TimeConv.h"
#endif
#ifndef Storage_H_
#include "Storage.h"
#endif
#ifndef useri_H_
#include "useri.h"
#endif
#ifndef aprstext_H_
#include "aprstext.h"
#endif



long maptool_xsize;
long maptool_ysize;
float maptool_shiftx;
float maptool_shifty;


struct maptool__D0 maptool_mappack;
/* aprs tracks on osm map by oe5dxl */
/*<* IF TARGET_FAMILY="UNIX" THEN *> */
/*<* END *> */
#define maptool_LF "\012"

#define maptool_MAXCOL 30000

#define maptool_SYMX 16

#define maptool_SYMY 16

#define maptool_SYMN 192

#define maptool_MAPGETFN "gettiles"
/* tiles request filename */

#define maptool_MAXFONTY 18

#define maptool_MINFONTY 7

#define maptool_DEFAULTFONTY 10

#define maptool_FONTFN "font.png"

#define maptool_PNGEXT ".png"

#define maptool_JPGEXT ".jpg"

#define maptool_CHARS 97

struct PIX8;


struct PIX8 {
   unsigned char r8;
   unsigned char g8;
   unsigned char b8;
};

typedef struct PIX8 ROWS0[256];

typedef struct PIX8 * pROWS0;

typedef pROWS0 PNGBUF[256];

typedef pROWS0 * pPNGBUF;

typedef char FN[1024];

struct SRTMCACHE;


struct SRTMCACHE {
   long fd; /* open ertm tile */
   float resol; /* tile resolution m */
   struct aprspos_POSITION base;
   float divx;
   float divy;
   unsigned long xdeg;
   unsigned long ydeg;
   unsigned long xlast;
   unsigned long ylast;
   unsigned long xpix;
   unsigned long ypix;
   long alt; /* last read altitude */
   unsigned long buf0;
   unsigned long buf1;
   char buf[64];
   unsigned long open;
   unsigned long miss;
   unsigned long hit;
};

static struct PIX8 symbols[3072][17];

static PNGBUF pngbuf;

struct _0;


struct _0 {
   unsigned char char0[19][8];
   unsigned short mask[21];
   unsigned char width;
};

static struct _0 font[97];

static char gammatab[1024];

static unsigned long maploadstart;

static char mapnamesbuf[4096]; /* tile name buffer */

static unsigned char mapnamesdone;

/* tile names written to file */
static unsigned long lastmapreq; /* time of last map requested */

static unsigned long maploopcnt;

/* count same tile requests */
static unsigned long mapdelay; /* delay map load start on map moves */

static struct SRTMCACHE srtmcache;


static float sqr(float x)
{
   return x*x;
} /* end sqr() */

#define maptool_GAMMA 4.5454545454545E-1


static void makegammatab(void)
{
   unsigned long c;
   gammatab[0U] = 0;
   for (c = 1UL; c<=1023UL; c++) {
      gammatab[c] = (char)aprsdecode_trunc((float)(exp(log((double)
                (X2C_DIVR((float)c,1024.0f)))*4.5454545454545E-1)*255.5));
   } /* end for */
} /* end makegammatab() */


extern void maptool_clr(maptool_pIMAGE img)
{
   unsigned long x;
   unsigned long tmp;
   tmp = img->Len1-1;
   x = 0UL;
   if (x<=tmp) for (;; x++) {
      memset((char *)(img->Adr+(x)*img->Len0),(char)0,img->Size1);
      if (x==tmp) break;
   } /* end for */
} /* end clr() */


extern char maptool_vistime(unsigned long t)
{
   return aprsdecode_systime<t+aprsdecode_lums.maxdim+aprsdecode_lums.firstdim;
                
} /* end vistime() */


extern void maptool_limpos(struct aprspos_POSITION * pos)
{
   if (pos->long0>3.1415926535898f) pos->long0 = 3.1415926535898f;
   else if (pos->long0<(-3.1415926535898f)) pos->long0 = (-3.1415926535898f);
   if (pos->lat>1.484f) pos->lat = 1.484f;
   else if (pos->lat<(-1.484f)) pos->lat = (-1.484f);
} /* end limpos() */


extern void maptool_startmapdelay(void)
{
   mapdelay = (unsigned long)useri_conf2int(useri_fDELAYGETMAP, 0UL, 0L, 60L,
                 0L);
   lastmapreq = aprsdecode_realtime;
   maploopcnt = 0UL; /* operator moves map */
} /* end startmapdelay() */


static void findinfo(long nx, long ny)
{
   long d;
   unsigned long i;
   struct aprsdecode__D0 * anonym;
   { /* with */
      struct aprsdecode__D0 * anonym = &aprsdecode_click;
      d = labs(anonym->x-nx)+labs(anonym->y-ny);
      /*IF (d<=5) & (ops<>NIL) THEN WrInt(d, 3);WrInt(entries, 3);
                WrStrLn(ops^.call); END; */
      if (d<=anonym->min0 && anonym->ops) {
         /* ops to ignore cc text */
         if (anonym->min0>0L) anonym->entries = 0UL;
         else if (anonym->entries>9UL) anonym->entries = 9UL;
         anonym->min0 = d;
         i = 0UL;
         while (i<anonym->entries && anonym->table[i].opf!=anonym->ops) ++i;
         anonym->table[i].opf = anonym->ops;
         anonym->table[i].pff = anonym->pf;
         anonym->table[i].pff0 = anonym->pf0;
         anonym->table[i].typf = anonym->typ;
         if (i>=anonym->entries) ++anonym->entries;
      }
   }
} /* end findinfo() */


extern void maptool_area(maptool_pIMAGE img, long x0, long y00, long x1,
                long y1, struct aprsdecode_COLTYP col0, char add)
{
   long h;
   long yy;
   long xx;
   struct maptool_PIX * anonym;
   long tmp;
   long tmp0;
   if (x0>x1) {
      h = x0;
      x0 = x1;
      x1 = h;
   }
   if (y00>y1) {
      h = y00;
      y00 = y1;
      y1 = h;
   }
   if (x0<0L) x0 = 0L;
   if (x1<0L) x1 = 0L;
   if (y00<0L) y00 = 0L;
   if (y1<0L) y1 = 0L;
   if (x0>(long)(img->Len1-1)) x0 = (long)(img->Len1-1);
   if (x1>(long)(img->Len1-1)) x1 = (long)(img->Len1-1);
   if (y00>(long)(img->Len0-1)) y00 = (long)(img->Len0-1);
   if (y1>(long)(img->Len0-1)) y1 = (long)(img->Len0-1);
   tmp = y1;
   yy = y00;
   if (yy<=tmp) for (;; yy++) {
      tmp0 = x1;
      xx = x0;
      if (xx<=tmp0) for (;; xx++) {
         { /* with */
            struct maptool_PIX * anonym = &img->Adr[(xx)*img->Len0+yy];
            if (add) {
               anonym->r += (unsigned short)col0.r;
               anonym->g += (unsigned short)col0.g;
               anonym->b += (unsigned short)col0.b;
            }
            else {
               anonym->r = (unsigned short)col0.r;
               anonym->g = (unsigned short)col0.g;
               anonym->b = (unsigned short)col0.b;
            }
         }
         if (xx==tmp0) break;
      } /* end for */
      if (yy==tmp) break;
   } /* end for */
} /* end area() */


extern float maptool_realzoom(long zi, float zf)
{
   return ((float)zi+zf)-1.0f;
} /* end realzoom() */


static float expzoom(long z)
{
   return (float)(unsigned long)X2C_LSH(0x1UL,32,z);
} /* end expzoom() */


extern void maptool_xytodeg(float x, float y, struct aprspos_POSITION * pos)
{
   long zi;
   float ysf;
   float zoom;
   float pixrad;
   zoom = maptool_realzoom(aprsdecode_initzoom, aprsdecode_finezoom);
   ysf = (float)maptool_ysize;
   y = ysf-y;
   if (y<0.0f) y = 0.0f;
   else if (y>ysf) y = ysf;
   if ((float)fabs(aprsdecode_mappos.lat)>1.484f) {
      aprsdecode_posinval(pos);
      return;
   }
   zi = (long)aprsdecode_trunc(zoom);
   pixrad = X2C_DIVR(6.2831853071796f,
                ((1.0f+zoom)-(float)zi)*256.0f*expzoom((long)
                aprsdecode_trunc(zoom)));
   pos->long0 = aprsdecode_mappos.long0+pixrad*x;
   pos->lat = (float)(2.0*atan(exp(log(tan((double)aprsdecode_mappos.lat)
                +X2C_DIVL(1.0,cos((double)aprsdecode_mappos.lat)))-(double)(pixrad*y)))-1.5707963267949);
   maptool_limpos(pos);
} /* end xytodeg() */


extern void maptool_shiftmap(long x, long y, long ysize, float zoom,
                struct aprspos_POSITION * pos)
{
   long zi;
   float pixrad;
   zi = (long)aprsdecode_trunc(zoom);
   pixrad = ((1.0f+zoom)-(float)zi)*256.0f*expzoom((long)
                aprsdecode_trunc(zoom));
   pos->long0 = pos->long0-(X2C_DIVR(6.2831853071796f,pixrad))*(float)x;
   pos->lat = (float)(2.0*atan(exp(log(tan((double)pos->lat)+X2C_DIVL(1.0,
                cos((double)pos->lat)))+(double)((X2C_DIVR(6.2831853071796f,
                pixrad))*(float)(ysize-y))))-1.5707963267949);
   maptool_limpos(pos);
} /* end shiftmap() */


extern void maptool_center(long xsize, long ysize, float zoom,
                struct aprspos_POSITION centpos,
                struct aprspos_POSITION * pos)
{
   long zi;
   float pixrad;
   zi = (long)aprsdecode_trunc(zoom);
   pixrad = ((1.0f+zoom)-(float)zi)*256.0f*expzoom((long)
                aprsdecode_trunc(zoom));
   pos->long0 = centpos.long0-(X2C_DIVR(6.2831853071796f,
                pixrad))*(float)X2C_DIV(xsize,2L);
   pos->lat = (float)(2.0*atan(exp(log(tan((double)centpos.lat)+X2C_DIVL(1.0,
                cos((double)centpos.lat)))+(double)
                ((X2C_DIVR(6.2831853071796f,pixrad))*(float)X2C_DIV(ysize,
                2L))))-1.5707963267949);
   maptool_limpos(pos);
} /* end center() */

#define maptool_TOL 0.0001


extern void maptool_mercator(float lon, float lat, long zoom, long * tilex,
                long * tiley, float * x, float * y)
{
   float z;
   struct X2C_XHandler_STR anonym;
   if (X2C_XTRY(&anonym)) {
      if (lat>1.484f) lat = 1.484f;
      else if (lat<(-1.484f)) lat = (-1.484f);
      if (lon>3.1414926535898f) lon = 3.1414926535898f;
      else if (lon<(-3.1414926535898f)) lon = (-3.1414926535898f);
      lat = (float)log(tan((double)lat)+X2C_DIVL(1.0,cos((double)lat)));
      z = expzoom(zoom);
      *x = (0.5f+lon*1.591549430919E-1f)*z;
      *y = (0.5f-lat*1.591549430919E-1f)*z;
      *tilex = (long)aprsdecode_trunc(*x);
      *tiley = (long)aprsdecode_trunc(*y);
      *x = (*x-(float)*tilex)*256.0f;
      *y = (*y-(float)*tiley)*256.0f;
      X2C_XOFF();
   }
   else {
      osi_WrStrLn("error in mercator", 18ul);
      *tilex = 0L;
      *tiley = 0L;
      *x = 0.0f;
      *y = 0.0f;
      X2C_XON();
   }
   X2C_XREMOVE();
} /* end mercator() */


extern long maptool_mapxy(struct aprspos_POSITION pos, float * x, float * y)
{
   long tiley;
   long tilex;
   float ys;
   float xs;
   if (aprspos_posvalid(pos)) {
      maptool_mercator(pos.long0, pos.lat, aprsdecode_initzoom, &tilex,
                &tiley, x, y);
      tilex -= aprsdecode_inittilex;
      tiley -= aprsdecode_inittiley;
      *x = ((*x+(float)(tilex*256L))-maptool_shiftx)*aprsdecode_finezoom;
      *y = (float)maptool_ysize-(((float)(tiley*256L)+*y)-maptool_shifty)
                *aprsdecode_finezoom;
      /*WrFixed(x, 5, 10); WrFixed(FLOAT(xsize), 5, 10); WrFixed(y, 5, 10);
                WrFixed(FLOAT(ysize), 5, 10); WrLn; */
      /*doreorder error:    IF (x>=0.0) & (x<=FLOAT(xsize)) & (y>=0.0)
                & (y<=FLOAT(ysize)) THEN RETURN 0 END; */
      xs = (float)maptool_xsize;
      ys = (float)maptool_ysize;
      if (((*x>=0.0f && *x<=xs) && *y>=0.0f) && *y<=ys) return 0L;
   }
   return -1L;
} /* end mapxy() */


extern void maptool_pullmap(long x, long y, char init)
{
   struct aprspos_POSITION top;
   unsigned long i;
   if (init) {
      maptool_xytodeg((float)x, (float)y, &aprsdecode_click.pullpos);
      xosi_sethand(xosi_cPULL4);
      xosi_pulling = 1;
   }
   else {
      for (i = 0UL; i<=9UL; i++) {
         maptool_xytodeg((float)x, (float)y, &top);
         aprsdecode_mappos.lat = aprsdecode_mappos.lat-(top.lat-aprsdecode_click.pullpos.lat)
                *0.5f;
         aprsdecode_mappos.long0 = aprsdecode_mappos.long0-(top.long0-aprsdecode_click.pullpos.long0)
                ;
         maptool_limpos(&aprsdecode_mappos);
      } /* end for */
   }
} /* end pullmap() */


extern void maptool_loctopos(struct aprspos_POSITION * pos, char loc[],
                unsigned long loc_len)
{
   unsigned long i;
   unsigned long tmp;
   X2C_PCOPY((void **)&loc,loc_len);
   tmp = loc_len-1;
   i = 0UL;
   if (i<=tmp) for (;; i++) {
      loc[i] = X2C_CAP(loc[i]);
      if (i==tmp) break;
   } /* end for */
   if (((((((((((((loc_len-1==5UL || loc[6UL]==0) && (unsigned char)
                loc[0UL]>='A') && (unsigned char)loc[0UL]<='R')
                && (unsigned char)loc[1UL]>='A') && (unsigned char)
                loc[1UL]<='R') && (unsigned char)loc[2UL]>='0')
                && (unsigned char)loc[2UL]<='9') && (unsigned char)
                loc[3UL]>='0') && (unsigned char)loc[3UL]<='9')
                && (unsigned char)loc[4UL]>='A') && (unsigned char)
                loc[4UL]<='X') && (unsigned char)loc[5UL]>='A')
                && (unsigned char)loc[5UL]<='X') {
      pos->long0 = (((float)((unsigned long)(unsigned char)loc[0UL]-65UL)
                *20.0f+(float)((unsigned long)(unsigned char)loc[2UL]-48UL)
                *2.0f+X2C_DIVR((float)((unsigned long)(unsigned char)
                loc[4UL]-65UL)+0.5f,12.0f))-180.0f)*1.7453292519943E-2f;
      pos->lat = (((float)((unsigned long)(unsigned char)loc[1UL]-65UL)
                *10.0f+(float)((unsigned long)(unsigned char)loc[3UL]-48UL)
                +X2C_DIVR((float)((unsigned long)(unsigned char)
                loc[5UL]-65UL)+0.5f,24.0f))-90.0f)*1.7453292519943E-2f;
   }
   else {
      pos->lat = 0.0f;
      pos->long0 = 0.0f;
   }
   X2C_PFREE(loc);
} /* end loctopos() */


extern void maptool_postoloc(char loc[], unsigned long loc_len,
                struct aprspos_POSITION pos)
{
   unsigned long bc;
   unsigned long lc;
   float br;
   float lr;
   maptool_limpos(&pos);
   lr = (pos.long0*5.7295779513082E+1f+180.0f)*12.0f;
   if (lr<0.0f) lr = 0.0f;
   lc = aprsdecode_trunc(lr);
   br = (pos.lat*5.7295779513082E+1f+90.0f)*24.0f;
   if (br<0.0f) br = 0.0f;
   bc = aprsdecode_trunc(br);
   loc[0UL] = (char)(65UL+lc/240UL);
   loc[1UL] = (char)(65UL+bc/240UL);
   loc[2UL] = (char)(48UL+(lc/24UL)%10UL);
   loc[3UL] = (char)(48UL+(bc/24UL)%10UL);
   loc[4UL] = (char)(65UL+lc%24UL);
   loc[5UL] = (char)(65UL+bc%24UL);
   loc[6UL] = 0;
} /* end postoloc() */

/*
PROCEDURE getsrtm13(pos:POSITION; typ:CHAR):INTEGER;
CONST SRTM3DIR="srtm3"; 
      SRTM3RES=1200;   
      SRTM1DIR="srtm1";
      SRTM1RES=3600;                                           (* pixel in srtm tile *)

VAR s:ARRAY[0..20] OF CHAR;
    path:FN;
    lati, longi, n, res:CARDINAL;
    latd, longd:REAL;
    h:INTEGER;
BEGIN
  limpos(pos);
  confstr(fOSMDIR, path);
  IF typ="3" THEN
    Append(path, DIRSEP+SRTM3DIR);
    res:=SRTM3RES;
  ELSE
    Append(path, DIRSEP+SRTM1DIR);
    res:=SRTM1RES;
  END;
  Append(path, DIRSEP);
  latd :=90.0 + pos.lat*(180.0/pi);
  longd:=180.0 + pos.long*(180.0/pi);
  lati:=trunc(latd);
  longi:=trunc(longd);
  IF lati<90 THEN s[0]:="S"; n:=90-lati ELSE s[0]:="N"; n:=lati-90 END;
  s[1]:=CHR(n DIV 10+ORD("0"));
  s[2]:=CHR(n MOD 10+ORD("0"));

  IF longi<180 THEN s[3]:="W"; n:=180-longi ELSE s[3]:="E"; n:=longi-180 END;
  s[4]:=CHR(n DIV 100+ORD("0"));
  s[5]:=CHR(n DIV 10 MOD 10+ORD("0"));
  s[6]:=CHR(n MOD 10+ORD("0"));
  s[7]:=".";
  s[8]:="h";
  s[9]:="g";
  s[10]:="t";
  s[11]:=0C;
  Append(path, s);
  IF NOT FdValid(srtmfd) OR NOT StrCmp(path, srtmfn) THEN
    IF FdValid(srtmfd) THEN Close(srtmfd) END;
    srtmfd:=OpenRead(path);
    srtmfn:=path;
  END;
  IF NOT FdValid(srtmfd) THEN
    IF verb THEN WrStr(path); WrStrLn(" not found"); END;
    RETURN MAX(INTEGER)

  END;

  latd:=latd-FLOAT(lati);
  longd:=longd-FLOAT(longi);
  latd :=(1.0-latd)*FLOAT(res);
  longd:=longd*FLOAT(res);
--WrInt(trunc(latd), 10); WrInt(trunc(longd), 10); WrStrLn("xy");

  n:=trunc(longd) + trunc(latd)*(res+1);
  Seek(srtmfd, n*2);
  IF RdBin(srtmfd, s, 2)=2 THEN
    h:=ORD(s[1]) + ORD(s[0])*256;
--WrInt(h, 10); WrStrLn("=hgt");
    IF h>=32768 THEN h:=h-65536 END;
    IF h<=-32767 THEN h:=MAX(INTEGER) END;
  ELSE h:=MAX(INTEGER) END;
--  Close(fd);
  RETURN h
END getsrtm13;


PROCEDURE getsrtm30(pos:POSITION):INTEGER;
CONST SRTM30DIR="srtm30";

VAR s:ARRAY[0..20] OF CHAR;
    path:ARRAY[0..1000] OF CHAR;
    lati, longi, n:CARDINAL;
    fd:File;
    latd, longd:REAL;
    h:INTEGER;
BEGIN
  limpos(pos);
  confstr(fOSMDIR, path);
  Append(path, DIRSEP+SRTM30DIR);
  Append(path, DIRSEP);
  latd :=90.0 + pos.lat*(180.0/pi);
  longd:=180.0 + pos.long*(180.0/pi);

  longi:=trunc(longd) DIV 40*40;
  IF longi<180 THEN s[0]:="W"; n:=180-longi ELSE s[0]:="E"; n:=longi-180 END;
  s[1]:=CHR(n DIV 100+ORD("0"));
  s[2]:=CHR(n DIV 10 MOD 10+ORD("0"));
  s[3]:=CHR(n MOD 10+ORD("0"));

  lati:=trunc(latd);
  IF lati>=130   THEN latd:=180.0-latd;  s[4]:="N"; s[5]:="9";
  ELSIF lati>=90 THEN latd:=130.0-latd;  s[4]:="N"; s[5]:="4";
  ELSIF lati>=60 THEN latd:= 90.0-latd;  s[4]:="S"; s[5]:="0";
  ELSE                latd:= 40.0-latd;  s[4]:="S"; s[5]:="4" END;
  s[6]:="0"; 
  s[7]:=".";
  s[8]:="D";
  s[9]:="E";
  s[10]:="M";
  s[11]:=0C;
  Append(path, s);
  fd:=OpenRead(path);
  IF NOT FdValid(fd) THEN
    IF verb THEN WrStr(path); WrStrLn(" not found"); END;
    RETURN MAX(INTEGER)

  END;

  longd:=longd-FLOAT(longi);
  longd:=longd*120.0;
--WrInt(trunc(longd), 10); WrInt(trunc(latd), 10); WrStrLn("xy");

  n:=trunc(longd) + trunc(latd*120.0)*4800;
--WrInt(n, 15); WrStrLn(" n");
  Seek(fd, n*2);
  IF RdBin(fd, s, 2)=2 THEN
    h:=ORD(s[1]) + ORD(s[0])*256;
--WrInt(h, 10); WrStrLn("=hgt");
    IF h>=32768 THEN h:=h-65536 END;
    IF h<=-32767 THEN h:=MAX(INTEGER) END;
  ELSE h:=MAX(INTEGER) END;
  Close(fd);
  RETURN h
END getsrtm30;


PROCEDURE getsrtm(pos:POSITION; VAR resolution:REAL):INTEGER;
VAR nn:INTEGER;
BEGIN
  nn:=getsrtm13(pos, "1");
  resolution:=30.0;
  IF nn=MAX(INTEGER) THEN nn:=getsrtm13(pos,"3"); resolution:=90.0 END;
  IF nn=MAX(INTEGER) THEN nn:=getsrtm30(pos); resolution:=900.0 END;
  RETURN nn
END getsrtm;
*/
#define maptool_SRTM3DIR "srtm3"

#define maptool_SRTM1DIR "srtm1"

#define maptool_SRTM30DIR "srtm30"


static void opensrtm(struct aprspos_POSITION pos, unsigned char typ)
{
   char s[21];
   FN path;
   unsigned long res;
   unsigned long xi;
   unsigned long n;
   float longd;
   float latd;
   struct SRTMCACHE * anonym;
   latd = 90.0f+pos.lat*5.7295779513082E+1f;
   longd = 180.0f+pos.long0*5.7295779513082E+1f;
   { /* with */
      struct SRTMCACHE * anonym = &srtmcache;
      maptool_limpos(&pos);
      useri_confstr(useri_fOSMDIR, path, 1024ul);
      anonym->resol = 0.0f;
      if (typ==3U) {
         aprsstr_Append(path, 1024ul, "/srtm3/", 8ul);
         res = 1200UL;
         anonym->resol = 90.0f;
      }
      else if (typ==1U) {
         aprsstr_Append(path, 1024ul, "/srtm1/", 8ul);
         res = 3600UL;
         anonym->resol = 30.0f;
      }
      anonym->ydeg = aprsdecode_trunc(latd);
      anonym->xdeg = aprsdecode_trunc(longd);
      if (anonym->resol!=0.0f) {
         if (anonym->ydeg<90UL) {
            s[0U] = 'S';
            n = 90UL-anonym->ydeg;
         }
         else {
            s[0U] = 'N';
            n = anonym->ydeg-90UL;
         }
         s[1U] = (char)(n/10UL+48UL);
         s[2U] = (char)(n%10UL+48UL);
         if (anonym->xdeg<180UL) {
            s[3U] = 'W';
            n = 180UL-anonym->xdeg;
         }
         else {
            s[3U] = 'E';
            n = anonym->xdeg-180UL;
         }
         s[4U] = (char)(n/100UL+48UL);
         s[5U] = (char)((n/10UL)%10UL+48UL);
         s[6U] = (char)(n%10UL+48UL);
         s[7U] = '.';
         s[8U] = 'h';
         s[9U] = 'g';
         s[10U] = 't';
         anonym->base.lat = (float)(anonym->ydeg+1UL);
         anonym->base.long0 = (float)anonym->xdeg;
         anonym->divx = (float)res;
         anonym->divy = anonym->divx;
         anonym->xpix = res+1UL;
         anonym->ypix = anonym->xpix;
      }
      else {
         anonym->resol = 900.0f;
         aprsstr_Append(path, 1024ul, "/srtm30/", 9ul);
         xi = (anonym->xdeg/40UL)*40UL;
         if (xi<180UL) {
            s[0U] = 'W';
            n = 180UL-xi;
         }
         else {
            s[0U] = 'E';
            n = xi-180UL;
         }
         s[1U] = (char)(n/100UL+48UL);
         s[2U] = (char)((n/10UL)%10UL+48UL);
         s[3U] = (char)(n%10UL+48UL);
         if (anonym->ydeg>=130UL) {
            anonym->base.lat = 180.0f;
            anonym->ypix = 6000UL;
            s[4U] = 'N';
            s[5U] = '9';
         }
         else if (anonym->ydeg>=90UL) {
            anonym->base.lat = 130.0f;
            anonym->ypix = 4800UL;
            s[4U] = 'N';
            s[5U] = '4';
         }
         else if (anonym->ydeg>=50UL) {
            anonym->base.lat = 90.0f;
            anonym->ypix = 4800UL;
            s[4U] = 'S';
            s[5U] = '0';
         }
         else {
            anonym->base.lat = 50.0f;
            anonym->ypix = 6000UL;
            s[4U] = 'S';
            s[5U] = '4';
         }
         s[6U] = '0';
         s[7U] = '.';
         s[8U] = 'D';
         s[9U] = 'E';
         s[10U] = 'M';
         anonym->base.long0 = (float)xi;
         anonym->divx = 120.0f;
         anonym->divy = anonym->divx;
         anonym->xpix = 4800UL;
      }
      s[11U] = 0;
      aprsstr_Append(path, 1024ul, s, 21ul);
      anonym->fd = osi_OpenRead(path, 1024ul);
      anonym->buf1 = 0UL;
      anonym->buf0 = 0UL;
      ++anonym->open;
   }
} /* end opensrtm() */


static void findsrtm(struct aprspos_POSITION pos)
{
   maptool_limpos(&pos);
   if (srtmcache.fd==-1L) {
      opensrtm(pos, 1U);
      if (srtmcache.fd==-1L) {
         opensrtm(pos, 3U);
         if (srtmcache.fd==-1L) opensrtm(pos, 30U);
      }
   }
} /* end findsrtm() */


static char readsrtm(struct aprspos_POSITION pos)
{
   unsigned long i;
   /*    s:ARRAY[0..1] OF CHAR; */
   unsigned long y;
   unsigned long x;
   struct SRTMCACHE * anonym;
   pos.lat = 90.0f+pos.lat*5.7295779513082E+1f;
   pos.long0 = 180.0f+pos.long0*5.7295779513082E+1f;
   { /* with */
      struct SRTMCACHE * anonym = &srtmcache;
      if (anonym->xdeg==aprsdecode_trunc(pos.long0)
                && anonym->ydeg==aprsdecode_trunc(pos.lat)) {
         /* we are in same degree else check if finer resolution exists */
         pos.lat = anonym->base.lat-pos.lat;
         pos.long0 = pos.long0-anonym->base.long0;
         if (pos.lat>=0.0f && pos.long0>=0.0f) {
            x = aprsdecode_trunc(pos.long0*anonym->divx);
            y = aprsdecode_trunc(pos.lat*anonym->divy);
            if (x<anonym->xpix && y<anonym->ypix) {
               if ((y!=anonym->ylast || x<anonym->buf0) || x>=anonym->buf1) {
                  ++anonym->miss;
                  i = 16UL;
                  if (x<16UL) anonym->buf0 = 0UL;
                  else anonym->buf0 = x-16UL;
                  anonym->buf1 = anonym->buf0+32UL;
                  if (anonym->buf1>anonym->xpix) {
                     anonym->buf1 = anonym->xpix;
                     anonym->buf0 = anonym->buf1-32UL;
                  }
                  if (anonym->xpix-x<16UL) i = anonym->xpix-x;
                  osi_Seek(anonym->fd, (anonym->buf0+y*anonym->xpix)*2UL);
                  if (osi_RdBin(anonym->fd, (char *)anonym->buf, 64u/1u,
                64UL)!=64L) {
                     anonym->buf0 = 0UL;
                     anonym->buf1 = 0UL;
                     anonym->alt = X2C_max_longint;
                     return 1;
                  }
               }
               else ++anonym->hit;
               i = (x-anonym->buf0)*2UL;
               anonym->alt = (long)((unsigned long)(unsigned char)
                anonym->buf[i+1UL]+(unsigned long)(unsigned char)
                anonym->buf[i]*256UL);
               if (anonym->alt>=32768L) anonym->alt = anonym->alt-65536L;
               if (anonym->alt<=-32767L) anonym->alt = X2C_max_longint;
               anonym->xlast = x;
               anonym->ylast = y;
               return 1;
            }
         }
      }
   }
   /*
           IF (x=xlast) & (y=ylast) THEN INC(hit); RETURN TRUE END;
   
           IF (x<xpix) & (y<ypix) THEN
   INC(miss);
             xlast:=x;
             ylast:=y;
             Seek(fd, (x + y*xpix)*2);
             IF RdBin(fd, s, 2)=2 THEN
               alt:=ORD(s[1]) + ORD(s[0])*256;
               IF alt>=32768 THEN alt:=alt-65536 END;
               IF alt<=-32767 THEN alt:=MAX(INTEGER) END;
             ELSE alt:=MAX(INTEGER) END;
             RETURN TRUE
   
           END;
   */
   return 0;
} /* end readsrtm() */


static void closesrtmfile(void)
{
   if (srtmcache.fd!=-1L) {
      osi_Close(srtmcache.fd);
      srtmcache.fd = -1L;
   }
} /* end closesrtmfile() */


extern long maptool_getsrtm(struct aprspos_POSITION pos, float * resolution)
{
   long nn;
   nn = X2C_max_longint;
   if (srtmcache.fd==-1L) findsrtm(pos);
   if (srtmcache.fd!=-1L) {
      if (readsrtm(pos)) nn = srtmcache.alt;
      else {
         closesrtmfile();
         findsrtm(pos);
         if (srtmcache.fd!=-1L && readsrtm(pos)) nn = srtmcache.alt;
      }
   }
   *resolution = srtmcache.resol;
   return nn;
} /* end getsrtm() */

/*
PROCEDURE wgs84(lat, long, heig:REAL; VAR x,y,z:REAL);       (* wgs84 ecef *)
CONST
      A=6378137;
--      B=6356752;
--      F=(A-B)/A;
--      E=2*F-F*F;
      E=0.081819190842522;

VAR n,sl,h:REAL;
BEGIN
  sl:=sin(lat);
  n:=A/sqrt(1.0-E*E*sl*sl);
  h:=heig+n;
  z:=(n*(1.0-E*E)+heig)*sl;
  y:=h*sin(long)*cos(lat);
  x:=h*cos(long)*cos(lat);
END wgs84;
*/

static void wgs84s(float lat, float long0, float nn, float * x, float * y,
                float * z)
/* km */
{
   float h;
   h = nn+6370.0f;
   *z = (float)((double)h*sin((double)lat));
   *y = (float)((double)h*sin((double)long0)*cos((double)lat));
   *x = (float)((double)h*cos((double)long0)*cos((double)lat));
} /* end wgs84s() */


static void wgs84r(float x, float y, float z, float * lat, float * long0,
                float * heig)
/* km */
{
   float h;
   h = x*x+y*y;
   if ((float)fabs(x)>(float)fabs(y)) {
      *long0 = (float)atan((double)(X2C_DIVR(y,x)));
      if (x<0.0f) {
         if (y>0.0f) *long0 = 3.1415926535898f+*long0;
         else *long0 = *long0-3.1415926535898f;
      }
   }
   else {
      *long0 = (float)(1.5707963267949-atan((double)(X2C_DIVR(x,y))));
      if (y<0.0f) *long0 = *long0-3.1415926535898f;
   }
   *lat = (float)atan(X2C_DIVL((double)z,sqrt((double)h)));
   *heig = (float)(sqrt((double)(h+z*z))-6370.0);
} /* end wgs84r() */


static float fresnel(float a, float b, float lambda)
{
   if (lambda==0.0f) return 0.0f;
   else return (float)sqrt((double)(X2C_DIVR(lambda*a*b,a+b)));
   return 0;
} /* end fresnel() */

#define maptool_M 700


static void frescol(float a, unsigned short * r, unsigned short * g,
                unsigned short * b)
{
   *b = 700U;
   *r = 0U;
   *g = 100U;
   if (a<=0.001f) {
      *r = 700U;
      *g = 0U;
      *b = 0U;
   }
   else if (a<0.999f) {
      *b = 0U;
      if (a<0.5f) {
         *r = 700U;
         *g = (unsigned short)aprsdecode_trunc(a*1400.0f);
      }
      else {
         *g = 700U;
         *r = (unsigned short)aprsdecode_trunc((1.0f-a)*1400.0f);
      }
   }
} /* end frescol() */

#define maptool_SCALEHLINES 0.1
/* size of headroom lines to rf path size */

#define maptool_DOTSTEP 2

#define maptool_MAXDIST 1000000

#define maptool_HERR (-2.E+4)

struct HTAB;

typedef struct HTAB * pHTAB;


struct HTAB {
   pHTAB next;
   float tx;
   float ty;
   float alt;
};


extern long maptool_geoprofile(maptool_pIMAGE image,
                struct aprspos_POSITION pos0, struct aprspos_POSITION pos1,
                float lambda, char ant1nn, long ant1, long ant2,
                float * dist, float * dbi, float * a1, float * a2)
{
   long fstep;
   long fs;
   long nn;
   float yproj;
   float xproj;
   float ysh;
   float xsh;
   float wdif;
   float a;
   float resol;
   float hmid;
   float h1;
   float h0;
   float dh;
   float fullsum;
   float fresmin;
   float fressum;
   float odist;
   float nv;
   float kf;
   float yo;
   float xo;
   float maxfres;
   float fres;
   float y;
   float x;
   float d;
   float h;
   float dz;
   float dy;
   float dx;
   float z1;
   float y1;
   float x1;
   float z0;
   float y00;
   float x0;
   struct aprspos_POSITION posf;
   struct aprspos_POSITION pos;
   unsigned short red;
   unsigned short green;
   unsigned short blue;
   pHTAB pht;
   pHTAB phtab;
   long tmp;
   srtmcache.open = 0UL;
   srtmcache.miss = 0UL;
   srtmcache.hit = 0UL;
   *dbi = 0.0f;
   *dist = 0.0f;
   if (ant1nn) nn = 0L;
   else {
      nn = maptool_getsrtm(pos0, &resol);
      if (nn==X2C_max_longint) {
         closesrtmfile();
         return -1L;
      }
   }
   *a1 = (float)(nn+ant1);
   wgs84s(pos0.lat, pos0.long0,  *a1*0.001f, &x0, &y00, &z0);
   nn = maptool_getsrtm(pos1, &resol);
   if (nn==X2C_max_longint) {
      closesrtmfile();
      return -1L;
   }
   *a2 = (float)(nn+ant2);
   wgs84s(pos1.lat, pos1.long0,  *a2*0.001f, &x1, &y1, &z1);
   x1 = x1-x0;
   y1 = y1-y00;
   z1 = z1-z0;
   *dist = (float)(sqrt((double)(x1*x1+y1*y1+z1*z1))*1000.0);
   if (*dist<1.0f) {
      closesrtmfile();
      return -3L;
   }
   if (*dist>1.E+6f) {
      closesrtmfile();
      return -2L;
   }
   if (lambda!=0.0f) {
      *dbi = (float)(32.2+8.685889638065*log((double)(X2C_DIVR( *dist*0.3f,
                lambda))));
   }
   odist = X2C_DIVR(0.7071f,*dist); /* step 1/sqrt(2) of map resolution */
   d = 0.0f;
   maxfres = fresnel( *dist*0.5f,  *dist*0.5f, lambda);
   if (maxfres==0.0f) maxfres = 1.0f;
   xo = 0.0f;
   yo = 0.0f;
   fresmin = 1.0f;
   nv = (float)aprspos_azimuth(pos0, pos1)*1.7453292519943E-2f;
   phtab = 0;
   do {
      fres = fresnel( *dist*d,  *dist*(1.0f-d), lambda);
      dx = x0+x1*d;
      dy = y00+y1*d;
      dz = z0+z1*d;
      wgs84r(dx, dy, dz, &pos.lat, &pos.long0, &hmid);
      if (maptool_mapxy(pos, &x, &y)>=0L) {
         hmid = hmid*1000.0f;
         fressum = 0.0f;
         fullsum = 0.0f;
         fstep = (long)aprsdecode_trunc(X2C_DIVR(fres*0.5f,resol));
         tmp = fstep;
         fs = -fstep;
         if (fs<=tmp) for (;; fs++) {
            kf = (X2C_DIVR((float)fs*resol,2.E+7f))*3.1415926535898f;
            posf.lat = (float)((double)pos.lat+(double)kf*sin((double)nv));
            posf.long0 = (float)((double)pos.long0-(double)kf*cos((double)nv)
                );
            dh = sqr(fres*0.5f)-sqr((float)fs*resol);
            nn = maptool_getsrtm(posf, &resol);
            if (nn==X2C_max_longint) h = (-2.E+4f);
            else h = (float)nn;
            if (dh>0.0f) {
               dh = (float)sqrt((double)dh);
               h0 = hmid-dh;
               h1 = hmid+dh;
               /*WrFixed(dh, 3, 10); WrFixed(h0, 3, 10); WrFixed(h1, 3, 10);
                WrStrLn(" dh"); */
               fullsum = fullsum+(h1-h0);
               /*WrFixed(h, 3, 10); WrFixed(h0, 3, 10); WrStrLn(" hh0"); */
               if (h>h0) h0 = h;
               if (h1>h0) fressum = fressum+(h1-h0);
            }
            else {
               fullsum = 1.0f;
               if (h<hmid) fressum = 1.0f;
            }
            if (fs==tmp) break;
         } /* end for */
         if (fullsum>0.0f) {
            fressum = X2C_DIVR(fressum,fullsum);
            if (fressum<fresmin) fresmin = fressum;
            /*WrFixed(fullsum, 3, 10); WrFixed(fressum, 3, 10);
                WrStrLn(" ff"); */
            if (sqr(xo-x)+sqr(yo-y)>4.0f) {
               if (h==(-2.E+4f)) {
                  maptool_waypoint(image, x, y, 1.5f, 500L, 500L, 500L);
                /* have no srtm */
               }
               else {
                  frescol(fresmin, &red, &green, &blue);
                  maptool_waypoint(image, x, y, 1.25f+X2C_DIVR(1.25f*fres,
                maxfres), (long)red, (long)green, (long)blue);
                  Storage_ALLOCATE((X2C_ADDRESS *) &pht,
                sizeof(struct HTAB));
                /* store headroom values for scaling later */
                  if (pht) {
                     pht->next = phtab;
                     phtab = pht;
                     pht->alt = hmid-(float)nn;
                /* meters over (or under) ground */
                     pht->tx = x; /* pixel on screen */
                     pht->ty = y;
                  }
               }
               /*
                           IF hdif<0.0 THEN red:=100; green:=0; blue:=0;
                      (* no sight *)
                           ELSE red:=0; green:=30; blue:=100 END;
                      (* sight *)
                           IF yproj<0.0 THEN hdif:=-hdif END;
                           xsh:=x+hdif*xproj;
                      (* rotate to normalvector *)
                           ysh:=y-hdif*yproj;
                      (* rotate to normalvector *)
                           vector(image, x,y,xsh,ysh, red,green,blue, 256,
                0.0);
                           waypoint(image, xsh, ysh, 1.5, red*3, green*3,
                blue*3);
               */
               xo = x;
               yo = y;
               fresmin = 1.0f;
            }
         }
      }
      d = d+resol*odist;
   } while (d<=1.0f);
   if (phtab) {
      pht = phtab;
      a = 1.0f;
      for (;;) {
         /* find maximum for scaling */
         if ((float)fabs(pht->alt)>a) a = (float)fabs(pht->alt);
         if (pht->next==0) break;
         pht = pht->next;
      }
      d = (float)sqrt((double)(1.0f+sqr(phtab->tx-pht->tx)
                +sqr(phtab->ty-pht->ty))); /* rftrack pixels on screen */
      wdif = sqr((float)((double)(pos0.long0-pos1.long0)*cos((double)
                pos0.lat)))+sqr(pos0.lat-pos1.lat);
      if (wdif!=0.0f) {
         wdif = (float)sqrt((double)wdif); /* dist pos0-pos1 */
         wdif = X2C_DIVR(wdif*a,d*0.1f);
         xproj = X2C_DIVR(pos0.lat-pos1.lat,wdif);
                /* 90 deg rotatationsvector */
         yproj = (float)(X2C_DIVL((double)(pos0.long0-pos1.long0)
                *cos((double)pos0.lat),(double)wdif));
                /* for headroom lines to track */
      }
      else {
         xproj = 0.0f;
         yproj = 0.0f;
      }
      while (phtab) {
         a = phtab->alt;
         if (a<0.0f) {
            red = 80U; /* no sight */
            green = 0U;
            blue = 0U;
         }
         else {
            red = 0U; /* sight */
            green = 30U;
            blue = 100U;
         }
         if (yproj<0.0f) a = -a;
         xsh = phtab->tx+a*xproj; /* rotate to normalvector */
         ysh = phtab->ty-a*yproj; /* rotate to normalvector */
         maptool_vector(image, phtab->tx, phtab->ty, xsh, ysh, (long)red,
                (long)green, (long)blue, 256UL, 0.0f); /* headroom line */
         maptool_waypoint(image, xsh, ysh, 1.5f, (long)(red*3U),
                (long)(green*3U), (long)(blue*3U));
                /* thicken end of headroom line */
         pht = phtab;
         phtab = phtab->next;
         Storage_DEALLOCATE((X2C_ADDRESS *) &pht, sizeof(struct HTAB));
      }
   }
   closesrtmfile();
   /*WrInt(srtmcache.open, 10); WrInt(srtmcache.miss, 10);
                WrInt(srtmcache.hit, 10); WrStrLn("=o.m.h"); */
   return 0L;
} /* end geoprofile() */


static void setcol(unsigned short bri, unsigned long colnr,
                struct maptool_PIX * p)
{
   if (colnr==0UL) {
      if (bri>p->r) p->r = bri;
   }
   else if (bri>p->g) p->g = bri;
} /* end setcol() */

#define maptool_DARKJUMP 0.5
/* shadow deepness to step relation */

#define maptool_INCSPEED 1.15
/* enlarge light beam search step size going away from tx */

#define maptool_STARTFINE 0.25
/* start step size as part of srtm resolution at tx pos */

#define maptool_FRAMESTEP 1.8
/* pixel step along corner of image */

#define maptool_RAYSTEP 1.8
/* pixel step along radiaton ray */

#define maptool_FULLUM 1000.0
/* full bright in image */


extern void maptool_Radiorange(maptool_pIMAGE image,
                struct aprspos_POSITION txpos, long ant1, long ant2,
                unsigned long smooth, unsigned long colnr, char * abort0)
{
   unsigned short bri;
   unsigned long far;
   unsigned long frame;
   unsigned long yp;
   unsigned long xp;
   long void0;
   long nn;
   float osmooth;
   float lum;
   float rais;
   float arx;
   float atx;
   float a;
   float resoltx;
   float resol;
   float odist;
   float dist;
   float yi;
   float xi;
   float minst;
   float st;
   float ytx;
   float xtx;
   float oy;
   float ox;
   float y;
   float x;
   float d;
   float hs;
   float h;
   float pz;
   float py;
   float px;
   float dz;
   float dy;
   float dx;
   float z1;
   float y1;
   float x1;
   float z0;
   float y00;
   float x0;
   struct aprspos_POSITION pos;
   unsigned long startt;
   unsigned long rt;
   char ss1[101];
   char ss[101];
   srtmcache.open = 0UL;
   srtmcache.miss = 0UL;
   srtmcache.hit = 0UL;
   startt = TimeConv_time();
   nn = maptool_getsrtm(txpos, &resoltx);
                /* altitude of tx an map resolution in m here */
   if (nn==X2C_max_longint) {
      closesrtmfile();
      return;
   }
   if (smooth>0UL) osmooth = X2C_DIVR(1000.0f,(float)smooth);
   else osmooth = 1000.0f;
   atx = (float)(nn+ant1);
   wgs84s(txpos.lat, txpos.long0, atx*0.001f, &x0, &y00, &z0);
   arx = (float)ant2;
   xi = 0.0f;
   yi = 0.0f;
   nn = maptool_mapxy(txpos, &xtx, &ytx);
   frame = 0UL;
   for (;;) {
      maptool_xytodeg(xi, yi, &pos);
      if (((frame==0UL && ytx>0.0f || frame==2UL && ytx<(float)maptool_ysize)
                 || frame==1UL && xtx>0.0f) || frame==3UL && xtx<(float)
                maptool_xsize) {
         wgs84s(pos.lat, pos.long0, atx*0.001f, &x1, &y1, &z1);
         dx = x1-x0;
         dy = y1-y00;
         dz = z1-z0;
         dist = (float)(sqrt((double)(dx*dx+dy*dy+dz*dz))*1000.0);
                /* sight line length in m */
         if (dist>1.0f) {
            odist = X2C_DIVR(1.0f,dist);
            minst = resoltx*odist*0.25f; /* fine start steps at tx pos */
            st = minst;
            d = 0.0f;
            rais = (-1.E+9f);
            far = 10UL; /* use more steps to measure size */
            ox = 0.0f;
            oy = 0.0f;
            for (;;) {
               d = d+st;
               if (d>1.0f) break;
               px = x0+dx*d;
               py = y00+dy*d;
               pz = z0+dz*d;
               wgs84r(px, py, pz, &pos.lat, &pos.long0, &a);
               a = a*1000.0f;
               nn = maptool_getsrtm(pos, &resol);
               if (nn==X2C_max_longint) break;
               h = (float)nn-a; /* m ground over searchpath */
               hs = rais*d; /* h sight line m over searchpath */
               if (h+arx>hs) {
                  /* rx antenna in sight */
                  if (maptool_mapxy(pos, &x, &y)>=0L) {
                     xp = (unsigned long)X2C_TRUNCC(x,0UL,X2C_max_longcard);
                     yp = (unsigned long)X2C_TRUNCC(y,0UL,X2C_max_longcard);
                     if (xp<image->Len1-1 && yp<image->Len0-1) {
                        /*
                                        setcol(image^[xp  ][yp  ], color);
                                        setcol(image^[xp+1][yp  ], color);
                                        setcol(image^[xp  ][yp+1], color);
                                        setcol(image^[xp+1][yp+1], color);
                        */
                        lum = ((h+arx)-hs)*osmooth;
                        if (lum>1000.0f) lum = 1000.0f;
                        if (xp>0UL && yp>0UL) {
                           /*
                           colh.r:=TRUNC(FLOAT(color.r)*lum);
                           colh.g:=TRUNC(FLOAT(color.g)*lum);
                           colh.b:=TRUNC(FLOAT(color.b)*lum);
                           
                                             setcol(image^[xp  ][yp  ]);
                                             setcol(image^[xp+1][yp  ]);
                                             setcol(image^[xp  ][yp+1]);
                                             setcol(image^[xp-1][yp  ]);
                                             setcol(image^[xp  ][yp-1]);
                           lum:=lum*0.5;
                           colh.r:=TRUNC(FLOAT(color.r)*lum);
                           colh.g:=TRUNC(FLOAT(color.g)*lum);
                           colh.b:=TRUNC(FLOAT(color.b)*lum);
                           
                                             setcol(image^[xp+1][yp+1]);
                                             setcol(image^[xp-1][yp+1]);
                                             setcol(image^[xp+1][yp-1]);
                                             setcol(image^[xp-1][yp+1]);
                           */
                           bri = (unsigned short)(unsigned long)
                X2C_TRUNCC(lum,0UL,X2C_max_longcard);
                           setcol(bri, colnr,
                &image->Adr[(xp)*image->Len0+yp]);
                           setcol(bri, colnr,
                &image->Adr[(xp+1UL)*image->Len0+yp]);
                           setcol(bri, colnr,
                &image->Adr[(xp)*image->Len0+(yp+1UL)]);
                           setcol(bri, colnr,
                &image->Adr[(xp-1UL)*image->Len0+yp]);
                           setcol(bri, colnr,
                &image->Adr[(xp)*image->Len0+(yp-1UL)]);
                           bri = bri/2U;
                           setcol(bri, colnr,
                &image->Adr[(xp+1UL)*image->Len0+(yp+1UL)]);
                           setcol(bri, colnr,
                &image->Adr[(xp-1UL)*image->Len0+(yp+1UL)]);
                           setcol(bri, colnr,
                &image->Adr[(xp+1UL)*image->Len0+(yp-1UL)]);
                           setcol(bri, colnr,
                &image->Adr[(xp-1UL)*image->Len0+(yp+1UL)]);
                        }
                     }
                  }
               }
               else if (far>0UL) void0 = maptool_mapxy(pos, &x, &y);
               if (far>0UL) {
                  /* increase step size */
                  if ((float)fabs(x-ox)+(float)fabs(y-oy)<1.8f) {
                     st = st*1.15f;
                  }
                  else {
                     if (st>minst) st = st*8.695652173913E-1f;
                     --far;
                  }
                  ox = x;
                  oy = y;
               }
               if (h>hs) rais = X2C_DIVR(h,d);
               else d = d+(hs-h)*0.5f*odist;
            }
         }
      }
      /* go along next side of image */
      switch (frame) {
      case 0UL:
         xi = xi+(1.0f+(float)fabs(X2C_DIVR(xi-xtx,yi-ytx)))*1.8f;
         if (xi>=(float)(image->Len1-1)) {
            xi = 0.0f;
            ++frame;
         }
         break;
      case 1UL:
         yi = yi+(1.0f+(float)fabs(X2C_DIVR(yi-ytx,xi-xtx)))*1.8f;
         if (yi>=(float)(image->Len0-1)) {
            yi = (float)(image->Len0-1);
            ++frame;
         }
         break;
      case 2UL:
         xi = xi+(1.0f+(float)fabs(X2C_DIVR(xi-xtx,yi-ytx)))*1.8f;
         if (xi>=(float)(image->Len1-1)) {
            xi = (float)(image->Len1-1);
            ++frame;
         }
         break;
      default:;
         if (yi>0.0f) {
            yi = yi-(1.0f+(float)fabs(X2C_DIVR(yi-ytx,xi-xtx)))*1.8f;
         }
         else goto loop_exit;
         break;
      } /* end switch */
      rt = TimeConv_time();
      if (rt!=aprsdecode_realtime) {
         aprsdecode_realtime = rt;
         if (startt+4UL<rt) {
            aprsdecode_click.cmd = 0;
            useri_refresh = 1;
            strncpy(ss,"radiorange",101u);
            if (colnr) aprsstr_Append(ss, 101ul, " 2", 3ul);
            aprsstr_IntToStr((long)(frame*25UL), 3UL, ss1, 101ul);
            aprsstr_Append(ss, 101ul, ss1, 101ul);
            aprsstr_Append(ss, 101ul, "% ESC to abort", 15ul);
            useri_textautosize(0L, 0L, 5UL, 0UL, 'g', ss, 101ul);
            pos = aprsdecode_mappos;
            xosi_Eventloop(1UL);
            /*      IF (click.cmd=<>0C) OR (pos.lat<>mappos.lat)
                OR (pos.long<>mappos.long)(*OR refresh*) THEN abort:=TRUE;
                EXIT END; */
            if (!aprsdecode_click.withradio) {
               *abort0 = 1;
               break;
            }
         }
      }
   }
   loop_exit:;
   useri_killmenuid(5UL);
   closesrtmfile();
/*WrInt(stat1, 10);WrInt(stat2, 10);WrInt(stat3, 10); WrInt(stat4, 10);
                WrStrLn(" maps whites jumps"); */
/*WrInt(srtmcache.open, 10); WrInt(srtmcache.miss, 10);
                WrInt(srtmcache.hit, 10); WrStrLn("=o.m.h"); */
} /* end Radiorange() */


extern void maptool_xytoloc(long x, long y, char s[], unsigned long s_len)
/* lat/long + locator of pointer pixel */
{
   struct aprspos_POSITION mpos;
   char h[101];
   long nn;
   float resol;
   maptool_xytodeg((float)x, (float)y, &mpos);
   aprstext_postostr(mpos, '3', s, s_len);
   aprsstr_Append(s, s_len, " ", 2ul);
   aprstext_postostr(mpos, '1', h, 101ul);
   aprsstr_Append(s, s_len, h, 101ul);
   aprsstr_Append(s, s_len, " ", 2ul);
   aprsstr_FixToStr(X2C_DIVR(mpos.lat,1.7453292519444E-2f), 6UL, h, 101ul);
   aprsstr_Append(s, s_len, h, 101ul);
   aprsstr_Append(s, s_len, " ", 2ul);
   aprsstr_FixToStr(X2C_DIVR(mpos.long0,1.7453292519444E-2f), 6UL, h, 101ul);
   aprsstr_Append(s, s_len, h, 101ul);
   aprsstr_Append(s, s_len, " ", 2ul);
   maptool_postoloc(h, 101ul, mpos);
   aprsstr_Append(s, s_len, h, 101ul);
   nn = maptool_getsrtm(mpos, &resol);
   if (nn<X2C_max_longint) {
      aprsstr_IntToStr(nn, 0UL, h, 101ul);
      aprsstr_Append(s, s_len, " ", 2ul);
      aprsstr_Append(s, s_len, h, 101ul);
      aprsstr_Append(s, s_len, "m", 2ul);
   }
   if (aprspos_posvalid(aprsdecode_click.markpos)) {
      /*(click.marktime=0) &*/
      aprsstr_FixToStr(aprspos_distance(aprsdecode_click.markpos, mpos), 4UL,
                 h, 101ul);
      aprsstr_Append(s, s_len, " ", 2ul);
      aprsstr_Append(s, s_len, h, 101ul);
      aprsstr_Append(s, s_len, "km ", 4ul);
      aprsstr_IntToStr((long)aprspos_azimuth(aprsdecode_click.markpos, mpos),
                 0UL, h, 101ul);
      aprsstr_Append(s, s_len, h, 101ul);
      aprsstr_Append(s, s_len, "\177", 2ul);
   }
} /* end xytoloc() */


extern void maptool_Colset(struct aprsdecode_COLTYP * c, char w)
{
   c->r = 256UL;
   c->g = 256UL;
   c->b = 256UL;
   if (w=='Y') c->b = 0UL;
   else if (w=='R') {
      c->b = 0UL;
      c->g = 0UL;
   }
   else if (w=='G') {
      c->r = 0UL;
      c->b = 0UL;
   }
   else if (w=='B') {
      c->r = 0UL;
      c->g = 60UL;
   }
   else if (w=='O') {
      c->b = 0UL;
      c->g = 150UL;
   }
   else if (w=='0') {
      c->r = 255UL;
      c->g = 40UL;
      c->b = 10UL;
   }
   else if (w=='1') {
      c->r = 240UL;
      c->g = 120UL;
      c->b = 10UL;
   }
   else if (w=='2') {
      c->r = 240UL;
      c->g = 190UL;
      c->b = 10UL;
   }
   else if (w=='3') {
      c->r = 240UL;
      c->g = 240UL;
      c->b = 10UL;
   }
   else if (w=='4') {
      c->r = 110UL;
      c->g = 240UL;
      c->b = 10UL;
   }
   else if (w=='5') {
      c->r = 10UL;
      c->g = 240UL;
      c->b = 210UL;
   }
   else if (w=='6') {
      c->r = 10UL;
      c->g = 190UL;
      c->b = 240UL;
   }
   else if (w=='7') {
      c->r = 10UL;
      c->g = 90UL;
      c->b = 240UL;
   }
   else if (w=='8') {
      c->r = 140UL;
      c->g = 10UL;
      c->b = 240UL;
   }
   else if (w=='9') {
      c->r = 240UL;
      c->g = 10UL;
      c->b = 220UL;
   }
} /* end Colset() */


static void addcol(struct maptool_PIX * pixel, long rr, long gg, long bb,
                long f)
{
   long fh;
   struct maptool_PIX * anonym;
   { /* with */
      struct maptool_PIX * anonym = pixel;
      fh = (long)anonym->r+X2C_DIV(rr*f,256L);
      if (fh<0L) fh = 0L;
      else if (fh>30000L) fh = 30000L;
      anonym->r = (unsigned short)fh;
      fh = (long)anonym->g+X2C_DIV(gg*f,256L);
      if (fh<0L) fh = 0L;
      else if (fh>30000L) fh = 30000L;
      anonym->g = (unsigned short)fh;
      fh = (long)anonym->b+X2C_DIV(bb*f,256L);
      if (fh<0L) fh = 0L;
      else if (fh>30000L) fh = 30000L;
      anonym->b = (unsigned short)fh;
   }
} /* end addcol() */


extern void maptool_waypoint(maptool_pIMAGE image, float x, float y, float r,
                 long rr, long gg, long bb)
{
   long ri;
   long ty;
   long tx;
   long yi;
   long xi;
   float h;
   float my;
   float mx;
   float fy;
   float fx;
   long tmp;
   long tmp0;
   if (((x>r && x<(float)((image->Len1-1)+1UL)-r) && y>r) && y<(float)
                ((image->Len0-1)+1UL)-r) {
      ri = (long)(aprsdecode_trunc(r)+1UL);
      tx = (long)aprsdecode_trunc(x);
      fx = x-(float)tx;
      ty = (long)aprsdecode_trunc(y);
      fy = y-(float)ty;
      tmp = ri;
      yi = -ri;
      if (yi<=tmp) for (;; yi++) {
         tmp0 = ri;
         xi = -ri;
         if (xi<=tmp0) for (;; xi++) {
            mx = (float)xi-fx;
            my = (float)yi-fy;
            h = mx*mx+my*my;
            if (h>0.0f) h = (float)sqrt((double)h);
            h = r-h;
            if (h>0.0f) {
               if (h>1.0f) h = 1.0f;
               addcol(&image->Adr[(tx+xi)*image->Len0+(ty+yi)], rr, gg, bb,
                (long)aprsdecode_trunc(h*256.0f));
            }
            if (xi==tmp0) break;
         } /* end for */
         if (yi==tmp) break;
      } /* end for */
   }
} /* end waypoint() */

#define maptool_K 65536

#define maptool_KF 256


extern void maptool_vector(maptool_pIMAGE image, float x0, float y00,
                float x1, float y1, long rr, long gg, long bb,
                unsigned long width, float glow)
{
   float ro;
   float w2;
   float w1;
   float r;
   float h;
   unsigned long f1;
   unsigned long iw2;
   unsigned long e1;
   unsigned long de0;
   unsigned long e0;
   unsigned long n0;
   unsigned long n;
   unsigned long yb;
   unsigned long ya;
   unsigned long yie;
   unsigned long yi;
   unsigned long xi;
   long fgg;
   long fbb;
   long frr;
   long k;
   char mirr;
   char mirror;
   char flip;
   struct X2C_XHandler_STR anonym;
   /*scissoring*/
   /* hor out */
   /* bottom out */
   /* top out */
   /*scissoring*/
   /*
     ya:=TRUNC((y0-h*ABS(r)-w2-0.5)*K);
   */
   /*      INC(yb, k); */
   /*    INC(ya, k); */
   if (X2C_XTRY(&anonym)) {
      mirr = y00>y1;
      if (x0>x1) {
         h = x1;
         x1 = x0;
         x0 = h;
         h = y1;
         y1 = y00;
         y00 = h;
         mirror = 1;
      }
      else mirror = 0;
      if (x0>=(float)((image->Len1-1)-1UL) || x1<=0.0f) goto label;
      if (x0<=0.0f) {
         y00 = y00+X2C_DIVR((y1-y00)*x0,x0-x1);
         x0 = 1.0f;
      }
      if (x1>=(float)((image->Len1-1)-1UL)) {
         y1 = y00+X2C_DIVR((y1-y00)*((float)((image->Len1-1)-1UL)-x0),x1-x0);
         x1 = (float)((image->Len1-1)-1UL);
      }
      if (y00<=0.0f) {
         if (y1<=0.0f) goto label;
         x0 = x0+X2C_DIVR((x1-x0)*y00,y00-y1);
         y00 = 1.0f;
      }
      else if (y00>=(float)((image->Len0-1)-1UL)) {
         if (y1>=(float)((image->Len0-1)-1UL)) goto label;
         x0 = x0+X2C_DIVR((x1-x0)*((float)((image->Len0-1)-1UL)-y00),y1-y00);
         y00 = (float)((image->Len0-1)-1UL);
      }
      if (y1<=0.0f) {
         x1 = x1+X2C_DIVR((x1-x0)*y1,y00-y1);
         y1 = 1.0f;
      }
      else if (y1>=(float)((image->Len0-1)-1UL)) {
         x1 = x0+X2C_DIVR((x1-x0)*((float)((image->Len0-1)-1UL)-y00),y1-y00);
         y1 = (float)((image->Len0-1)-1UL);
      }
      if (x0<2.0f) x0 = 2.0f;
      if (x0>(float)((image->Len1-1)-1UL)) x0 = (float)((image->Len1-1)-1UL);
      if (y00<2.0f) y00 = 2.0f;
      if (y00>(float)((image->Len0-1)-1UL)) {
         y00 = (float)((image->Len0-1)-1UL);
      }
      if (x1<2.0f) x1 = 2.0f;
      if (x1>(float)((image->Len1-1)-1UL)) x1 = (float)((image->Len1-1)-1UL);
      if (y1<2.0f) y1 = 2.0f;
      if (y1>(float)((image->Len0-1)-1UL)) y1 = (float)((image->Len0-1)-1UL);
      w1 = X2C_DIVR((float)width,512.0f);
      if (x1-x0<(float)fabs(y1-y00)) {
         h = x0;
         x0 = y00;
         y00 = h;
         h = x1;
         x1 = y1;
         y1 = h;
         flip = 1;
      }
      else flip = 0;
      if (x0>x1) {
         h = y1;
         y1 = y00;
         y00 = h;
         h = x1;
         x1 = x0;
         x0 = h;
         mirror = !mirror;
      }
      if (x1==x0) goto label;
      h = X2C_DIVR(y1-y00,x1-x0);
      ro = (float)sqrt((double)(1.0f+h*h));
      w2 = w1*ro;
      iw2 = aprsdecode_trunc(w2*65536.0f);
      r = (float)((double)w1*sin(atan((double)h)));
      xi = aprsdecode_trunc(x0-(float)fabs(r));
      w1 = (((y00-h*(float)fabs(r))-w2)-0.5f)*65536.0f;
      if (w1<0.0f) ya = 0UL;
      else ya = aprsdecode_trunc(w1);
      e0 = iw2*2UL;
      yb = ya+e0;
      if ((float)fabs(r)>0.1f) {
         de0 = aprsdecode_trunc(X2C_DIVR((float)e0,(float)fabs(r)*2.0f));
      }
      else de0 = e0;
      k = (long)X2C_TRUNCI(h*65536.0f,X2C_min_longint,X2C_max_longint);
      n = aprsdecode_trunc((x1-(float)xi)+(float)fabs(r));
      mirr = y00>y1;
      if (aprsdecode_click.dryrun) ya = (ya+yb)/2UL;
      glow = X2C_DIVR(glow,ro);
      e1 = 0UL;
      n0 = n;
      while (n>0UL) {
         if (aprsdecode_click.dryrun) {
            yi = ya/65536UL;
            if (flip) {
               findinfo((long)(yi-1UL), (long)xi);
               findinfo((long)yi, (long)xi);
               findinfo((long)(yi+1UL), (long)xi);
            }
            else {
               findinfo((long)xi, (long)(yi-1UL));
               findinfo((long)xi, (long)yi);
               findinfo((long)xi, (long)(yi+1UL));
            }
         }
         else {
            if (mirror) h = (float)n;
            else h = (float)(n0-n);
            if (h<glow) {
               h = X2C_DIVR(h,glow);
               frr = (long)aprsdecode_trunc((float)rr*(1.125f-h)*6.0f);
               fgg = (long)aprsdecode_trunc((float)gg*h);
               fbb = (long)aprsdecode_trunc((float)bb*h);
            }
            else {
               frr = rr;
               fbb = bb;
               fgg = gg;
            }
            if (mirr) {
               if (e0>de0) {
                  yie = yb-e0;
                  e0 -= de0;
               }
               else yie = yb;
               if (n<=aprsdecode_trunc((float)fabs(r)*2.0f)) ya += de0;
               yi = ya;
            }
            else {
               if (e0>de0) {
                  yi = ya+e0;
                  e0 -= de0;
               }
               else yi = ya;
               if (n<=aprsdecode_trunc((float)fabs(r)*2.0f)) yb -= de0;
               yie = yb;
            }
            f1 = 256UL-(yi&65535UL)/256UL;
            yi = (yi/65536UL)*65536UL;
            do {
               if (flip) {
                  addcol(&image->Adr[(yi/65536UL)*image->Len0+xi], frr, fgg,
                fbb, (long)f1);
               }
               else {
                  addcol(&image->Adr[(xi)*image->Len0+yi/65536UL], frr, fgg,
                fbb, (long)f1);
               }
               yi += 65536UL;
               f1 = 256UL;
            } while (yi<yie);
            f1 = ((65536UL+yie)-yi&65535UL)/256UL;
            if (flip) {
               addcol(&image->Adr[(yi/65536UL)*image->Len0+xi], frr, fgg,
                fbb, (long)f1);
            }
            else {
               addcol(&image->Adr[(xi)*image->Len0+yi/65536UL], frr, fgg,
                fbb, (long)f1);
            }
            yb = (unsigned long)((long)yb+k);
         }
         ya = (unsigned long)((long)ya+k);
         ++xi;
         --n;
      }
      label:;
      X2C_XOFF();
   }
   else {
   }
   X2C_XREMOVE();
} /* end vector() */


extern void maptool_setmark(maptool_pIMAGE image,
                struct aprspos_POSITION pos, char hard)
{
   long i;
   float y;
   float x;
   struct aprsdecode_COLTYP col0;
   if (aprspos_posvalid(pos) && maptool_mapxy(pos, &x, &y)>=0L) {
      col0.r = 0UL;
      col0.g = 1000UL;
      col0.b = 1000UL;
      if (hard) {
         col0.r = 1000UL;
         col0.b = 0UL;
      }
      for (i = -6L; i<=6L; i++) {
         maptool_waypoint(image, x+(float)(i*3L), y, 1.3f, (long)col0.r,
                (long)col0.g, (long)col0.b);
         maptool_waypoint(image, x, y+(float)(i*3L), 1.3f, (long)col0.r,
                (long)col0.g, (long)col0.b);
      } /* end for */
   }
} /* end setmark() */

#define maptool_ALPHA 255

#define maptool_WHITE 1023


static void dim(float dimmlev, maptool_pIMAGE img, long x, long y)
{
   float lum;
   struct maptool_PIX * anonym;
   if (((x<0L || x>=(long)(img->Len1-1)) || y<0L) || y>=(long)(img->Len0-1)) {
      return;
   }
   { /* with */
      struct maptool_PIX * anonym = &img->Adr[(x)*img->Len0+y];
      lum = (float)((unsigned long)anonym->r*87UL+(unsigned long)
                anonym->g*140UL+(unsigned long)anonym->b*28UL);
      if (lum>dimmlev) {
         lum = X2C_DIVR(dimmlev,lum);
         anonym->r = (unsigned short)aprsdecode_trunc((float)anonym->r*lum);
         anonym->g = (unsigned short)aprsdecode_trunc((float)anonym->g*lum);
         anonym->b = (unsigned short)aprsdecode_trunc((float)anonym->b*lum);
      }
   }
} /* end dim() */


extern void maptool_drawchar(maptool_pIMAGE img, char ch, float x0r,
                float y0r, long * inc0, unsigned long bri,
                unsigned long contrast, struct aprsdecode_COLTYP col0,
                char dryrun)
{
   long fine;
   long yy;
   long xx;
   long y00;
   long x0;
   long y;
   long x;
   unsigned long cn;
   unsigned long cf;
   unsigned long c;
   unsigned long fy;
   unsigned long fx;
   float dimmlev;
   struct _0 * anonym;
   struct maptool_PIX * anonym0;
   struct maptool_PIX * anonym1;
   struct maptool_PIX * anonym2;
   struct maptool_PIX * anonym3;
   long tmp;
   if (((unsigned char)ch>=' ' && x0r>=0.0f) && y0r>=0.0f) {
      cn = (unsigned long)(unsigned char)ch-32UL;
      if (cn>96UL) cn = 0UL;
      dimmlev = 20480.0f;
      if (contrast==1UL) {
         dimmlev = (float)((col0.r*87UL+col0.g*140UL+col0.b*28UL)*bri)
                *0.002f;
      }
      x0 = (long)aprsdecode_trunc(x0r);
      y00 = (long)aprsdecode_trunc(y0r);
      fx = aprsdecode_trunc((x0r-(float)x0)*256.0f);
      fy = aprsdecode_trunc((y0r-(float)y00)*256.0f);
      fine = (long)(unsigned long)(fx || fy);
      { /* with */
         struct _0 * anonym = &font[cn];
         if (contrast>0UL && !dryrun) {
            tmp = (long)(aprsdecode_lums.fontysize-1UL);
            y = 0L;
            if (y<=tmp) for (;; y++) {
               for (x = 0L; x<=15L; x++) {
                  /*
                              IF hicontrast & (mask[y]<>SET16{}
                ) OR (x IN mask[y]) THEN dim(x0+x, y0+y) END;
                  */
                  if (X2C_IN(x,16,anonym->mask[y])) {
                     dim(dimmlev, img, x0+x+fine, y00+y);
                  }
               } /* end for */
               if (y==tmp) break;
            } /* end for */
         }
         tmp = (long)(aprsdecode_lums.fontysize-3UL);
         y = 0L;
         if (y<=tmp) for (;; y++) {
            yy = y00+y+1L;
            for (x = 0L; x<=7L; x++) {
               xx = x0+x+1L;
               c = ((unsigned long)anonym->char0[y][x]*bri)/256UL;
               if ((((c>0UL && xx>=0L) && xx+1L<(long)(img->Len1-1))
                && yy>=0L) && yy+1L<(long)(img->Len0-1)) {
                  if (dryrun) findinfo(xx, yy);
                  else {
                     cf = (c*(256UL-fx)*(256UL-fy))/65536UL;
                     { /* with */
                        struct maptool_PIX * anonym0 = &img->Adr[(xx)
                *img->Len0+yy];
                        anonym0->r += (unsigned short)((cf*col0.r)/256UL);
                        anonym0->g += (unsigned short)((cf*col0.g)/256UL);
                        anonym0->b += (unsigned short)((cf*col0.b)/256UL);
                        if (((unsigned long)anonym0->g+col0.g&1)) {
                           --anonym0->g; /* even is invert enable */
                        }
                     }
                     if (fine) {
                        /* save cpu */
                        cf = (c*fx*(256UL-fy))/65536UL;
                        { /* with */
                           struct maptool_PIX * anonym1 = &img->Adr[(xx+1L)
                *img->Len0+yy];
                           anonym1->r += (unsigned short)((cf*col0.r)/256UL);
                           anonym1->g += (unsigned short)((cf*col0.g)/256UL);
                           anonym1->b += (unsigned short)((cf*col0.b)/256UL);
                        }
                        cf = (c*(256UL-fx)*fy)/65536UL;
                        { /* with */
                           struct maptool_PIX * anonym2 = &img->Adr[(xx)
                *img->Len0+(yy+1L)];
                           anonym2->r += (unsigned short)((cf*col0.r)/256UL);
                           anonym2->g += (unsigned short)((cf*col0.g)/256UL);
                           anonym2->b += (unsigned short)((cf*col0.b)/256UL);
                        }
                        cf = (c*fx*fy)/65536UL;
                        { /* with */
                           struct maptool_PIX * anonym3 = &img->Adr[(xx+1L)
                *img->Len0+(yy+1L)];
                           anonym3->r += (unsigned short)((cf*col0.r)/256UL);
                           anonym3->g += (unsigned short)((cf*col0.g)/256UL);
                           anonym3->b += (unsigned short)((cf*col0.b)/256UL);
                        }
                     }
                  }
               }
            } /* end for */
            if (y==tmp) break;
         } /* end for */
         *inc0 = (long)(anonym->width+1U);
      }
   }
} /* end drawchar() */


extern unsigned long maptool_charwidth0(char ch)
{
   unsigned long cn;
   if ((unsigned char)ch>=' ') {
      cn = (unsigned long)(unsigned char)ch-32UL;
      if (cn>96UL) cn = 0UL;
      return (unsigned long)(font[cn].width+1U);
   }
   return 0UL;
} /* end charwidth() */

#define maptool_ALPHA0 220

#define maptool_WHITELEV 250


extern void maptool_drawsym(maptool_pIMAGE image, char tab, char sym,
                char mirror, float x0r, float y0r, unsigned long bri)
{
   long sx;
   long xi;
   long y00;
   long x0;
   long y;
   long x;
   unsigned long b;
   unsigned long br0d;
   unsigned long br1d;
   unsigned long br0c;
   unsigned long br1c;
   unsigned long br0b;
   unsigned long br1b;
   unsigned long br0a;
   unsigned long br1a;
   struct aprsdecode_COLTYP col0;
   unsigned long fy;
   unsigned long fx;
   struct PIX8 * anonym;
   struct maptool_PIX * anonym0;
   /* save cpu */
   struct maptool_PIX * anonym1;
   struct maptool_PIX * anonym2;
   struct maptool_PIX * anonym3;
   if (bri==0UL) return;
   sx = (long)(unsigned char)sym-32L;
   if (((((sx<=0L || sx>=96L) || x0r<(-16.0f)) || y0r<(-16.0f))
                || x0r>(float)((image->Len1-1)+16UL)) || y0r>(float)
                ((image->Len0-1)+16UL)) return;
   if (tab!='/') sx += 96L;
   sx = sx*16L;
   if (bri>255UL) bri = 255UL;
   x0 = (long)X2C_TRUNCI(x0r,X2C_min_longint,X2C_max_longint);
   y00 = (long)X2C_TRUNCI(y0r,X2C_min_longint,X2C_max_longint);
   if (x0<0L) fx = 0UL;
   else fx = aprsdecode_trunc((x0r-(float)x0)*256.0f);
   if (y00<0L) fy = 0UL;
   else fy = aprsdecode_trunc((y0r-(float)y00)*256.0f);
   x0 -= 8L;
   y00 -= 8L;
   b = (bri*(256UL-fx)*(256UL-fy))/65536UL;
   br1a = 256UL-b;
   br0a = (b*256000UL)/65536UL;
   if (fx || fy) {
      /* save cpu */
      b = (bri*fx*(256UL-fy))/65536UL;
      br1b = 256UL-b;
      br0b = (b*256000UL)/65536UL;
      b = (bri*(256UL-fx)*fy)/65536UL;
      br1c = 256UL-b;
      br0c = (b*256000UL)/65536UL;
      b = (bri*fx*fy)/65536UL;
      br1d = 256UL-b;
      br0d = (b*256000UL)/65536UL;
   }
   for (y = 0L; y<=15L; y++) {
      for (x = 0L; x<=15L; x++) {
         if (((x0+x>=0L && y00+y>=0L) && x+x0+1L<(long)(image->Len1-1))
                && y+y00+1L<(long)(image->Len0-1)) {
            if (mirror) xi = (15L-x)+sx;
            else xi = x+sx;
            { /* with */
               struct PIX8 * anonym = &symbols[xi][y];
               if ((anonym->r8<220U || anonym->g8<220U) || anonym->b8<220U) {
                  if (aprsdecode_click.dryrun) findinfo(x+x0, y+y00);
                  else {
                     { /* with */
                        struct maptool_PIX * anonym0 = &image->Adr[(x+x0)
                *image->Len0+(y+y00)];
                        anonym0->r = (unsigned short)(((unsigned long)
                anonym0->r*br1a+(unsigned long)anonym->r8*br0a)/256UL);
                        anonym0->g = (unsigned short)(((unsigned long)
                anonym0->g*br1a+(unsigned long)anonym->g8*br0a)/256UL);
                        anonym0->b = (unsigned short)(((unsigned long)
                anonym0->b*br1a+(unsigned long)anonym->b8*br0a)/256UL);
                     }
                     if (fx || fy) {
                        { /* with */
                           struct maptool_PIX * anonym1 = &image->Adr[(x+x0+1L)
                *image->Len0+(y+y00)];
                           anonym1->r = (unsigned short)(((unsigned long)
                anonym1->r*br1b+(unsigned long)anonym->r8*br0b)/256UL);
                           anonym1->g = (unsigned short)(((unsigned long)
                anonym1->g*br1b+(unsigned long)anonym->g8*br0b)/256UL);
                           anonym1->b = (unsigned short)(((unsigned long)
                anonym1->b*br1b+(unsigned long)anonym->b8*br0b)/256UL);
                        }
                        { /* with */
                           struct maptool_PIX * anonym2 = &image->Adr[(x+x0)
                *image->Len0+(y+y00+1L)];
                           anonym2->r = (unsigned short)(((unsigned long)
                anonym2->r*br1c+(unsigned long)anonym->r8*br0c)/256UL);
                           anonym2->g = (unsigned short)(((unsigned long)
                anonym2->g*br1c+(unsigned long)anonym->g8*br0c)/256UL);
                           anonym2->b = (unsigned short)(((unsigned long)
                anonym2->b*br1c+(unsigned long)anonym->b8*br0c)/256UL);
                        }
                        { /* with */
                           struct maptool_PIX * anonym3 = &image->Adr[(x+x0+1L)
                *image->Len0+(y+y00+1L)];
                           anonym3->r = (unsigned short)(((unsigned long)
                anonym3->r*br1d+(unsigned long)anonym->r8*br0d)/256UL);
                           anonym3->g = (unsigned short)(((unsigned long)
                anonym3->g*br1d+(unsigned long)anonym->g8*br0d)/256UL);
                           anonym3->b = (unsigned short)(((unsigned long)
                anonym3->b*br1d+(unsigned long)anonym->b8*br0d)/256UL);
                        }
                     }
                  }
               }
            }
         }
      } /* end for */
   } /* end for */
   if ((unsigned char)tab>='0' && (unsigned char)tab<='9' || (unsigned char)
                tab>='A' && (unsigned char)tab<='Z') {
      maptool_Colset(&col0, 'W');
      maptool_drawchar(image, tab, x0r-4.0f,
                y0r-((8.0f-(16.0f-(float)aprsdecode_lums.fontysize)*0.5f)
                +0.5f), &sx, bri*2UL, 1UL, col0, aprsdecode_click.dryrun);
   }
} /* end drawsym() */

#define maptool_HY 18

#define maptool_MARGIN 2


static void OptTextPlace(maptool_pIMAGE img, char s[], unsigned long s_len,
                long * xt, long * yt)
{
   unsigned long cn;
   unsigned long i;
   /*max,*/
   long fonty;
   long n;
   long ymin;
   long min0;
   long lb;
   long lg;
   long lr;
   long cont;
   long yh;
   long y;
   long x;
   long wid;
   long ct[54];
   struct maptool_PIX * anonym;
   long tmp;
   long tmp0;
   X2C_PCOPY((void **)&s,s_len);
   fonty = (long)(aprsdecode_lums.fontysize-3UL);
   if (((*xt<0L || *xt>=(long)(img->Len1-1)) || *yt<-fonty) || *yt>=(long)
                (img->Len0-1)+fonty) goto label;
   i = 0UL;
   wid = 0L;
   while (i<=s_len-1 && s[i]) {
      if ((unsigned char)s[i]>=' ') {
         cn = (unsigned long)(unsigned char)s[i]-32UL;
         if (cn>96UL) cn = 0UL;
         wid += (long)font[cn].width;
      }
      ++i;
   }
   min0 = X2C_max_longint;
   /*
     max:=0;
   */
   n = 0L;
   tmp = 3L*fonty-1L;
   y = 0L;
   if (y<=tmp) for (;; y++) {
      yh = (*yt+y)-fonty;
      /*  IF (yh>=MARGIN) & (yh<VAL(INTEGER,
                HIGH(img^[0])+1-lums.fontysize)-MARGIN)
                THEN (* never place text outside drawable *) */
      if (yh>=2L && yh<(long)((img->Len0-1)+1UL)-2L) {
         /* never place text outside drawable */
         cont = 0L;
         lr = 0L;
         lg = 0L;
         lb = 0L;
         tmp0 = (*xt+wid)-1L;
         x = *xt;
         if (x<=tmp0) for (;; x++) {
            if (x<(long)((img->Len1-1)-1UL)) {
               { /* with */
                  struct maptool_PIX * anonym = &img->Adr[(x)*img->Len0+yh];
                  cont += labs((long)anonym->r-lr)+labs((long)anonym->g-lg)
                +labs((long)anonym->b-lb);
                  lr = (long)anonym->r;
                  lg = (long)anonym->g;
                  lb = (long)anonym->b;
               }
            }
            if (x==tmp0) break;
         } /* end for */
      }
      else cont = wid*32768L;
      if (y<fonty || y>=fonty*2L) cont = X2C_DIV(cont*400L,256L);
      ct[y] = cont;
      n += cont;
      if (y>=fonty) {
         n -= ct[y-fonty];
         if (n<min0) {
            min0 = n;
            ymin = y;
         }
      }
      if (y==tmp) break;
   } /* end for */
   /*
         IF n>max THEN max:=n END;
   */
   *yt += ymin-fonty*2L;
   label:;
   X2C_PFREE(s);
} /* end OptTextPlace() */


extern void maptool_drawstr(maptool_pIMAGE image, char s[],
                unsigned long s_len, float xr, float yr, unsigned long bri,
                unsigned long contrast, struct aprsdecode_COLTYP col0,
                signed char * pos, unsigned long slide, char fixpos,
                char dryrun)
{
   unsigned long i;
   long y;
   long x;
   long inc0;
   long dy;
   if (bri==0UL) return;
   if (slide>0UL) {
      if (fixpos) yr = yr+(float)*pos;
      else {
         y = (long)X2C_TRUNCI(yr,X2C_min_longint,X2C_max_longint);
         x = (long)X2C_TRUNCI(xr,X2C_min_longint,X2C_max_longint);
         dy = y;
         OptTextPlace(image, s, s_len, &x, &y);
         y = X2C_DIV(y,2L)*2L+1L;
                /* not odd lines for better 420 color conversion */
         *pos = (signed char)(y-dy);
         xr = (float)x;
         yr = (float)y;
      }
   }
   i = 0UL;
   while (i<=s_len-1 && s[i]) {
      maptool_drawchar(image, s[i], xr, yr, &inc0, bri, contrast, col0,
                dryrun);
      xr = xr+(float)inc0;
      ++i;
   }
} /* end drawstr() */


extern void maptool_drawstri(maptool_pIMAGE image, char s[],
                unsigned long s_len, long xr, long yr, unsigned long bri,
                unsigned long contrast, struct aprsdecode_COLTYP col0,
                char proportional, char dryrun)
{
   unsigned long i;
   long inc0;
   char c;
   i = 0UL;
   for (;;) {
      if (i>s_len-1) break;
      c = s[i];
      if (c==0) break;
      if ((unsigned char)c>=(unsigned char)'\360' && (unsigned char)
                c<=(unsigned char)'\370') {
         xr += (long)((unsigned long)(unsigned char)c-239UL);
                /* microspaces */
      }
      else {
         maptool_drawchar(image, s[i], (float)xr, (float)yr, &inc0, bri,
                contrast, col0, dryrun);
         if (proportional) xr += inc0;
         else xr += 6L;
      }
      ++i;
   }
} /* end drawstri() */

#define maptool_L 7

#define maptool_WS 20
/* wind fethers per kmh */

#define maptool_LW 8

#define maptool_WW 4

#define maptool_A 0.12

#define maptool_W (-1.25)


extern void maptool_drawarrow(maptool_pIMAGE image, float x0, float y00,
                float len, float ang, unsigned long wind, unsigned long bri,
                struct aprsdecode_COLTYP col0)
{
   long wi;
   long b;
   long g;
   long r;
   float c1;
   float s1;
   float l;
   float c;
   float s;
   float y1;
   float x1;
   /*WrInt(wind, 10);WrStrLn("=w"); */
   s = (float)sin((double)ang);
   c = (float)cos((double)ang);
   r = (long)((bri*col0.r)/256UL);
   g = (long)((bri*col0.g)/256UL);
   b = (long)((bri*col0.b)/256UL);
   if (wind==0UL) {
      maptool_vector(image, x0, y00, x0-(len-5.0f)*s, y00+(len-5.0f)*c, r, g,
                 b, 400UL, 0.0f);
      x1 = x0-len*s;
      y1 = y00+len*c;
      l = len-7.0f;
      maptool_vector(image, x1, y1,
                (float)((double)x0-(double)l*sin((double)(ang+0.12f))),
                (float)((double)y00+(double)l*cos((double)(ang+0.12f))), r,
                g, b, 200UL, 0.0f);
      maptool_vector(image, x1, y1,
                (float)((double)x0-(double)l*sin((double)(ang-0.12f))),
                (float)((double)y00+(double)l*cos((double)(ang-0.12f))), r,
                g, b, 200UL, 0.0f);
   }
   else {
      len = len+(float)((4UL*wind)/20UL);
      maptool_vector(image, x0, y00, x0-len*s, y00+len*c, r, g, b, 250UL,
                0.0f);
      s1 = (float)sin((double)(ang+(-1.25f)));
      c1 = (float)cos((double)(ang+(-1.25f)));
      wi = (long)wind;
      if (wi<20L) wi = 20L;
      do {
         x1 = x0-len*s; /*-s1*/
         y1 = y00+len*c; /*+c1*/
         l = 8.0f;
         if (wi<20L) l = X2C_DIVR(8.0f*(float)wi,20.0f);
         maptool_vector(image, x1, y1, x1-l*s1, y1+l*c1, r, g, b, 250UL,
                0.0f);
         wi -= 20L;
         len = len-4.0f;
      } while (wi>0L);
   }
} /* end drawarrow() */


extern void maptool_cc(maptool_pIMAGE img, unsigned long from,
                unsigned long to)
{
   struct aprsdecode_COLTYP col0;
   char h[1024];
   char s[1024];
   signed char pos;
   aprsdecode_click.ops = 0;
   if (aprsdecode_lums.map>0L) {
      strncpy(s,"Maps:(c)www.openstreetmap.org",1024u);
   }
   else s[0] = 0;
   if (img->Len1-1>=399UL || aprsdecode_lums.map==0L) {
      aprsstr_Append(s, 1024ul, " Date:", 7ul);
      aprstext_DateLocToStr(from, h, 1024ul);
      aprsstr_Append(s, 1024ul, h, 1024ul);
      if (to) {
         aprsstr_Append(s, 1024ul, "-", 2ul);
         aprsstr_TimeToStr((to+useri_localtime())%86400UL, h, 1024ul);
         aprsstr_Append(s, 1024ul, h, 1024ul);
      }
   }
   maptool_Colset(&col0, 'G');
   aprsstr_Append(s, 1024ul, " Zoom:", 7ul);
   aprsstr_FixToStr(((float)aprsdecode_initzoom-0.995f)+aprsdecode_finezoom,
                3UL, h, 1024ul);
   aprsstr_Append(s, 1024ul, h, 1024ul);
   maptool_drawstr(img, s, 1024ul, 5.0f,
                (float)(((img->Len0-1)-aprsdecode_lums.fontysize)-25UL),
                300UL, 0UL, col0, &pos, 3UL, 0, aprsdecode_click.dryrun);
} /* end cc() */

#define maptool_RULERY 10

#define maptool_RULERX0 20

#define maptool_RULERX1 300


extern void maptool_ruler(maptool_pIMAGE img)
{
   struct aprspos_POSITION rpos;
   struct aprspos_POSITION lpos;
   char h[101];
   float e;
   float d;
   float r;
   unsigned long w;
   unsigned long m;
   signed char pos;
   struct aprsdecode_COLTYP col0;
   if (300L>maptool_xsize || aprsdecode_initzoom<6L) return;
   maptool_xytodeg(20.0f, 10.0f, &lpos);
   maptool_xytodeg(300.0f, 10.0f, &rpos);
   d = 1000.0f*aprspos_distance(lpos, rpos);
   if (d==0.0f) return;
   r = d;
   m = 1UL;
   while (r>=10.0f) {
      r = r*0.1f;
      m = m*10UL;
   }
   e = r;
   if (r>=5.0f) r = 5.0f;
   else if (r>=2.0f) r = 2.0f;
   else r = 1.0f;
   e = (X2C_DIVR(r,e))*280.0f;
   maptool_vector(img, 20.0f, 10.0f, 20.0f+e, 10.0f, 0L, 120L, 100L, 200UL,
                0.0f);
   maptool_vector(img, 20.0f, 7.0f, 20.0f, 13.0f, 0L, 120L, 100L, 200UL,
                0.0f);
   maptool_vector(img, 20.0f+e, 7.0f, 20.0f+e, 13.0f, 0L, 120L, 100L, 200UL,
                0.0f);
   m = m*aprsdecode_trunc(r);
   w = m;
   if (w>=1000UL) w = w/1000UL;
   aprsstr_IntToStr((long)w, 1UL, h, 101ul);
   if (m>=1000UL) aprsstr_Append(h, 101ul, "km", 3ul);
   else aprsstr_Append(h, 101ul, "m", 2ul);
   maptool_Colset(&col0, 'G');
   maptool_drawstr(img, h, 101ul, (20.0f+e*0.5f)-15.0f, 10.0f, 250UL, 0UL,
                col0, &pos, 0UL, 1, aprsdecode_click.dryrun);
} /* end ruler() */

#define maptool_VIS 80.0

#define maptool_PEAK 1000.0


static long smoo(float ex, long x)
{
   if (x<=0L) return x;
   else {
      return (long)aprsdecode_trunc((float)(exp(log((double)(X2C_DIVR((float)
                x,80.0f)))*(double)ex)*80.0));
   }
   return 0;
} /* end smoo() */

/*BEGIN RETURN trunc(FLOAT(x)/FLOAT(max)*5000.0) END smoo; */

extern void maptool_shine(maptool_pIMAGE image, long lum)
{
   long max0;
   long y;
   long x;
   unsigned long bb;
   unsigned long gg;
   unsigned long rr;
   unsigned long c;
   unsigned long f;
   char done;
   float ex;
   struct maptool_PIX * anonym;
   struct maptool_PIX * anonym0;
   struct maptool_PIX * anonym1;
   struct maptool_PIX * anonym2;
   struct maptool_PIX * anonym3;
   struct maptool_PIX * anonym4;
   struct maptool_PIX * anonym5;
   struct maptool_PIX * anonym6;
   struct maptool_PIX * anonym7;
   struct maptool_PIX * anonym8;
   struct maptool_PIX * anonym9;
   struct maptool_PIX * anonym10;
   struct maptool_PIX * anonym11;
   struct maptool_PIX * anonym12;
   struct maptool_PIX * anonym13;
   struct maptool_PIX * anonym14;
   long tmp;
   long tmp0;
   max0 = (long)(aprsdecode_trunc(80.0f)+1UL);
   tmp = (long)(image->Len0-1);
   y = 0L;
   if (y<=tmp) for (;; y++) {
      tmp0 = (long)(image->Len1-1);
      x = 0L;
      if (x<=tmp0) for (;; x++) {
         { /* with */
            struct maptool_PIX * anonym = &image->Adr[(x)*image->Len0+y];
            if ((long)anonym->g>max0) max0 = (long)anonym->g;
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
   ex = (float)(X2C_DIVL(log(12.5),log((double)(X2C_DIVR((float)max0,
                80.0f)))));
   if (ex>1.5f) ex = 1.5f;
   /*WrInt(max, 10);WrFixed(ex, 3,10);WrLn; */
   tmp = (long)(image->Len0-1);
   y = 0L;
   if (y<=tmp) for (;; y++) {
      tmp0 = (long)(image->Len1-1);
      x = 0L;
      if (x<=tmp0) for (;; x++) {
         { /* with */
            struct maptool_PIX * anonym0 = &image->Adr[(x)*image->Len0+y];
            anonym0->r = (unsigned short)smoo(ex, (long)anonym0->r);
            anonym0->g = (unsigned short)smoo(ex, (long)anonym0->g);
            anonym0->b = (unsigned short)smoo(ex, (long)anonym0->b);
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
   do {
      done = 1;
      tmp = (long)((image->Len0-1)-2UL);
      y = 2L;
      if (y<=tmp) for (;; y++) {
         tmp0 = (long)((image->Len1-1)-2UL);
         x = 2L;
         if (x<=tmp0) for (;; x++) {
            { /* with */
               struct maptool_PIX * anonym1 = &image->Adr[(x)*image->Len0+y];
                
               c = (unsigned long)(anonym1->r/2U);
               if ((unsigned long)anonym1->g>c) {
                  c = (unsigned long)anonym1->g;
               }
               if ((unsigned long)anonym1->b>c) {
                  c = (unsigned long)anonym1->b;
               }
               if (c>=256UL) {
                  rr = 0UL;
                  gg = 0UL;
                  bb = 0UL;
                  f = 65535UL/c;
                  c = ((unsigned long)anonym1->r*f)/256UL;
                  if ((unsigned long)anonym1->r>c) {
                     rr = ((unsigned long)anonym1->r-c)/10UL;
                  }
                  anonym1->r = (unsigned short)c;
                  c = ((unsigned long)anonym1->g*f)/256UL;
                  if ((unsigned long)anonym1->g>c) {
                     gg = ((unsigned long)anonym1->g-c)/12UL;
                  }
                  anonym1->g = (unsigned short)c;
                  c = ((unsigned long)anonym1->b*f)/256UL;
                  if ((unsigned long)anonym1->b>c) {
                     bb = ((unsigned long)anonym1->b-c)/12UL;
                  }
                  anonym1->b = (unsigned short)c;
                  { /* with */
                     struct maptool_PIX * anonym2 = &image->Adr[(x-1L)
                *image->Len0+(y-1L)];
                     anonym2->r += (unsigned short)rr;
                     anonym2->g += (unsigned short)gg;
                     anonym2->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym3 = &image->Adr[(x-1L)
                *image->Len0+y];
                     anonym3->r += (unsigned short)rr;
                     anonym3->g += (unsigned short)gg;
                     anonym3->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym4 = &image->Adr[(x-1L)
                *image->Len0+(y+1L)];
                     anonym4->r += (unsigned short)rr;
                     anonym4->g += (unsigned short)gg;
                     anonym4->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym5 = &image->Adr[(x+1L)
                *image->Len0+(y-1L)];
                     anonym5->r += (unsigned short)rr;
                     anonym5->g += (unsigned short)gg;
                     anonym5->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym6 = &image->Adr[(x+1L)
                *image->Len0+y];
                     anonym6->r += (unsigned short)rr;
                     anonym6->g += (unsigned short)gg;
                     anonym6->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym7 = &image->Adr[(x+1L)
                *image->Len0+(y+1L)];
                     anonym7->r += (unsigned short)rr;
                     anonym7->g += (unsigned short)gg;
                     anonym7->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym8 = &image->Adr[(x)
                *image->Len0+(y+1L)];
                     anonym8->r += (unsigned short)rr;
                     anonym8->g += (unsigned short)gg;
                     anonym8->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym9 = &image->Adr[(x)
                *image->Len0+(y-1L)];
                     anonym9->r += (unsigned short)rr;
                     anonym9->g += (unsigned short)gg;
                     anonym9->b += (unsigned short)bb;
                  }
                  { /* with */
                     struct maptool_PIX * anonym10 = &image->Adr[(x-2L)
                *image->Len0+y];
                     anonym10->r += (unsigned short)(rr/2UL);
                     anonym10->g += (unsigned short)(gg/2UL);
                     anonym10->b += (unsigned short)(bb/2UL);
                  }
                  { /* with */
                     struct maptool_PIX * anonym11 = &image->Adr[(x+2L)
                *image->Len0+y];
                     anonym11->r += (unsigned short)(rr/2UL);
                     anonym11->g += (unsigned short)(gg/2UL);
                     anonym11->b += (unsigned short)(bb/2UL);
                  }
                  { /* with */
                     struct maptool_PIX * anonym12 = &image->Adr[(x)
                *image->Len0+(y-2L)];
                     anonym12->r += (unsigned short)(rr/2UL);
                     anonym12->g += (unsigned short)(gg/2UL);
                     anonym12->b += (unsigned short)(bb/2UL);
                  }
                  { /* with */
                     struct maptool_PIX * anonym13 = &image->Adr[(x)
                *image->Len0+(y+2L)];
                     anonym13->r += (unsigned short)(rr/2UL);
                     anonym13->g += (unsigned short)(gg/2UL);
                     anonym13->b += (unsigned short)(bb/2UL);
                  }
                  done = 0;
               }
            }
            if (x==tmp0) break;
         } /* end for */
         if (y==tmp) break;
      } /* end for */
   } while (!done);
   tmp = (long)(image->Len0-1);
   y = 0L;
   if (y<=tmp) for (;; y++) {
      tmp0 = (long)(image->Len1-1);
      x = 0L;
      if (x<=tmp0) for (;; x++) {
         { /* with */
            struct maptool_PIX * anonym14 = &image->Adr[(x)*image->Len0+y];
            anonym14->r = (unsigned short)X2C_DIV((long)anonym14->r*lum,
                512L);
            anonym14->g = (unsigned short)X2C_DIV((long)anonym14->g*lum,
                512L);
            anonym14->b = (unsigned short)X2C_DIV((long)anonym14->b*lum,
                512L);
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
} /* end shine() */


extern void maptool_makebw(maptool_pIMAGE p)
{
   unsigned long w;
   unsigned long y;
   unsigned long x;
   struct maptool_PIX * anonym;
   unsigned long tmp;
   unsigned long tmp0;
   tmp = p->Len0-1;
   y = 0UL;
   if (y<=tmp) for (;; y++) {
      tmp0 = p->Len1-1;
      x = 0UL;
      if (x<=tmp0) for (;; x++) {
         { /* with */
            struct maptool_PIX * anonym = &p->Adr[(x)*p->Len0+y];
            w = ((unsigned long)anonym->r*340UL+(unsigned long)
                anonym->g*550UL+(unsigned long)anonym->b*110UL)/1000UL;
            anonym->r = (unsigned short)w;
            anonym->g = (unsigned short)w;
            anonym->b = (unsigned short)w;
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
} /* end makebw() */

/*
PROCEDURE lim(n:CARDINAL):CARD16;
BEGIN IF n>MAX(CARD16) THEN RETURN MAX(CARD16) ELSE RETURN n END; END lim;
*/

static void addpix(struct maptool_PIX * s, struct maptool_PIX * a)
{
   /*
      h:=s.r + a.r; IF h>MAX(CARD16) THEN s.r:=MAX(CARD16) ELSE s.r:=h END;
      h:=s.g + a.g; IF h>MAX(CARD16) THEN s.g:=MAX(CARD16) ELSE s.g:=h END;
      h:=s.b + a.b; IF h>MAX(CARD16) THEN s.b:=MAX(CARD16) ELSE s.b:=h END;
   */
   s->r += a->r;
   s->g += a->g;
   s->b += a->b;
} /* end addpix() */


extern void maptool_addmap(maptool_pIMAGE image, maptool_pIMAGE map)
{
   long y;
   long x;
   long tmp;
   long tmp0;
   tmp = (long)(image->Len1-1);
   x = 0L;
   if (x<=tmp) for (;; x++) {
      tmp0 = (long)(image->Len0-1);
      y = 0L;
      if (y<=tmp0) for (;; y++) {
         addpix(&image->Adr[(x)*image->Len0+y], &map->Adr[(x)*map->Len0+y]);
         if (y==tmp0) break;
      } /* end for */
      if (x==tmp) break;
   } /* end for */
/*
      image^[x+xsize*y].r:=lim(map^[x+xsize*y].r + image^[x+xsize*y].r);
      image^[x+xsize*y].g:=lim(map^[x+xsize*y].g + image^[x+xsize*y].g);
      image^[x+xsize*y].b:=lim(map^[x+xsize*y].b + image^[x+xsize*y].b);
*/
} /* end addmap() */

/*
PROCEDURE openppm(fn:ARRAY OF CHAR; verb:BOOLEAN):File;
VAR fd:File;
    line:INTEGER;
    ch, cho:CHAR;
BEGIN
  cleanfilename(fn);
  fd:=OpenRead(fn);
  IF NOT FdValid(fd) THEN 
    IF verb THEN WrStr(fn); WrStrLn(" not found"); END;
    RETURN InvalidFd;
  END;
 
  line:=0;
  cho:=0C;
  LOOP
    IF RdBin(fd, ch, 1)<>1 THEN 
      WrStr(fn); WrStrLn(" read error"); Close(fd); RETURN InvalidFd
    END;
    IF ch=LF THEN INC(line) END; 
    IF line=3 THEN EXIT END;
    IF (ch="#") & (cho=LF) THEN DEC(line) END;
    cho:=ch;
  END;
  RETURN fd
END openppm; 
*/

static void mapname(long x, long y, long zoom, char fn[],
                unsigned long fn_len, char reqn[], unsigned long reqn_len)
{
   char hh[21];
   char path[1001];
   fn[0UL] = 0;
   useri_confstr(useri_fOSMDIR, path, 1001ul);
   aprsstr_Append(fn, fn_len, path, 1001ul);
   aprsstr_Append(fn, fn_len, "/", 2ul);
   aprsstr_Append(fn, fn_len, aprsdecode_lums.mapname, 41ul);
   aprsstr_Append(fn, fn_len, "/", 2ul);
   /*WrInt(zoom,6);WrInt(x,6);WrInt(y,6);WrStrLn(" zoom x y"); */
   aprsstr_IntToStr(zoom, 1UL, hh, 21ul);
   aprsstr_Append(fn, fn_len, hh, 21ul);
   aprsstr_Append(fn, fn_len, "/", 2ul);
   /*    Append(fn, hh); */
   reqn[0UL] = 0;
   aprsstr_Append(reqn, reqn_len, aprsdecode_lums.mapname, 41ul);
   aprsstr_Append(reqn, reqn_len, " ", 2ul);
   aprsstr_Append(reqn, reqn_len, hh, 21ul);
   aprsstr_Append(reqn, reqn_len, " ", 2ul);
   /*
       IntToStr(x, 1, hh);
   
       Append(fn,"-");
       Append(fn, hh);
       Append(fn,"-");
   */
   aprsstr_IntToStr(x, 1UL, hh, 21ul);
   aprsstr_Append(fn, fn_len, hh, 21ul);
   aprsstr_Append(fn, fn_len, "/", 2ul);
   aprsstr_Append(reqn, reqn_len, hh, 21ul);
   aprsstr_Append(reqn, reqn_len, " ", 2ul);
   aprsstr_IntToStr(y, 1UL, hh, 21ul);
   aprsstr_Append(fn, fn_len, hh, 21ul);
   /*    Append(fn,".png"); */
   aprsstr_Append(reqn, reqn_len, hh, 21ul);
   aprsstr_Append(reqn, reqn_len, "\012", 2ul);
} /* end mapname() */


static unsigned long squaredelay(unsigned long c)
{
   unsigned long n;
   n = 1UL;
   while (c>0UL) {
      n += n;
      --c;
   }
   return n-1UL;
} /* end squaredelay() */


static char decodetile(const char fn[], unsigned long fn_len,
                pPNGBUF ppngbuf, long maxx, long maxy, long maxxbyte)
{
   char s[100];
   aprsstr_Assign(s, 100ul, fn, fn_len);
   aprsstr_Append(s, 100ul, ".png", 5ul);
   if (ppngbuf) {
      if (readpng(s, (X2C_ADDRESS *)ppngbuf, &maxx, &maxy,
                &maxxbyte)>=0L || readjpg(s, (X2C_ADDRESS *)ppngbuf, &maxx,
                &maxy, &maxxbyte)>=0L) {
         /* normal png in .png */
         return 1;
      }
   }
   else if (FileSys_Exists(s, 100ul)) {
      /* jpg hided in .png */
      return 1;
   }
   aprsstr_Assign(s, 100ul, fn, fn_len);
   aprsstr_Append(s, 100ul, ".jpg", 5ul);
   if (ppngbuf) {
      return readjpg(s, (X2C_ADDRESS *)ppngbuf, &maxx, &maxy, &maxxbyte)>=0L;
                
   }
   /* jpg in .jpg */
   return FileSys_Exists(s, 100ul);
} /* end decodetile() */

/*
PROCEDURE existsimg(fn-:ARRAY OF CHAR):BOOLEAN;
VAR s:ARRAY[0..99] OF CHAR;
BEGIN
  Assign(s, fn); Append(s, PNGEXT);
  IF Exists(s) THEN RETURN TRUE END;
  Assign(s, fn); Append(s, JPGEXT);
  RETURN Exists(s)
END existsimg;
*/
#define maptool_MAPLOADPROGSTARTDELAY 10

#define maptool_MINSPACE 80


static void reqmap(char wfn[], unsigned long wfn_len, char byop)
/* append filename of missing tiles to file, 0C is flush */
{
   char h[1000];
   char s[1000];
   long fd;
   unsigned long lb;
   X2C_PCOPY((void **)&wfn,wfn_len);
   /*WrStr(">");WrStr(wfn); */
   if (!byop) mapdelay = 0UL;
   if (mapnamesdone==1U) {
      /* filled buffer written */
      mapnamesdone = 0U;
      if (!FileSys_Exists("gettiles", 9ul)) {
         /* a maploader is at work */
         if ((byop && wfn[0UL]) && aprsstr_InStr(mapnamesbuf, 4096ul, wfn,
                wfn_len)>=0L) mapnamesdone = 2U;
         else maploopcnt = 0UL;
      }
      mapnamesbuf[0U] = 0;
   }
   if (maploopcnt<5UL || mapnamesbuf[0U]==0) {
      aprsstr_Append(mapnamesbuf, 4096ul, wfn, wfn_len);
                /* store 1 line if looping */
   }
   lb = aprsstr_Length(mapnamesbuf, 4096ul);
   if (lb>0UL && (wfn[0UL]==0 || lb+80UL>=4096UL)) {
      /* namebuffer full or flush */
      /*WrInt(maploopcnt, 10); WrInt(mapdelay, 10);
                WrInt(realtime-lastmapreq, 10); WrInt(realtime, 15);
                WrInt(lastmapreq, 15); WrStrLn(" delay");   */
      if (lastmapreq+mapdelay+squaredelay(maploopcnt)<=aprsdecode_realtime) {
         if (mapnamesdone==2U) {
            /* looping mapload */
            if (maploopcnt>=4UL) {
               useri_textautosize(0L, 0L, 5UL, 10UL, 'e', "get no map from do\
wnloader", 27ul);
            }
            if (maploopcnt<8UL) ++maploopcnt;
         }
         fd = osi_OpenWrite("gettiles", 9ul);
         if (osi_FdValid(fd)) {
            osi_WrBin(fd, (char *)mapnamesbuf, 4096u/1u, lb);
            osi_Close(fd);
            if (aprsdecode_verb) {
               InOut_WriteString("try:", 5ul);
               InOut_WriteInt((long)maploopcnt, 1UL);
               osi_WrStrLn(" written gettiles:", 19ul);
               InOut_WriteString(mapnamesbuf, 4096ul);
            }
            lastmapreq = aprsdecode_realtime;
            mapdelay = 0UL;
            if (maploadstart+10UL<aprsdecode_realtime) {
               /* delay for new start */
               /*WrStrLn("cp"); */
               if (aprsdecode_maploadpid.runs) {
                  xosi_CheckProg(&aprsdecode_maploadpid);
               }
               if (!aprsdecode_maploadpid.runs) {
                  /* start map load task */
                  /*WrStrLn("ps"); */
                  useri_confstr(useri_fGETMAPS, s, 1000ul);
                /* maploader program name */
                  if (s[0U]) {
                     useri_confstr(useri_fOSMDIR, h, 1000ul);
                     if (h[0U]) {
                        aprsstr_Append(s, 1000ul, " -r \"", 6ul);
                /* add -r rootdir */
                        aprsstr_Append(s, 1000ul, h, 1000ul);
                        aprsstr_Append(s, 1000ul, "\"", 2ul);
                     }
                     xosi_StartProg(s, 1000ul, &aprsdecode_maploadpid);
                     if (aprsdecode_maploadpid.runs) {
                        maploadstart = aprsdecode_realtime;
                        useri_textautosize(0L, 0L, 4UL, 3UL, 'g', "Start Mapd\
ownload", 18ul);
                     }
                     else {
                        strncpy(h,"can not start ",1000u);
                        aprsstr_Append(h, 1000ul, s, 1000ul);
                        useri_xerrmsg(h, 1000ul);
                        useri_refresh = 1;
                     }
                  }
               }
            }
            else if (maploadstart>aprsdecode_realtime) {
               maploadstart = 0UL; /* if clock jumped back */
            }
         }
         else osi_WrStrLn("cannot write gettiles", 22ul);
      }
      else if (lastmapreq>aprsdecode_realtime) {
         lastmapreq = aprsdecode_realtime; /* systime gone backward */
      }
      mapnamesdone = 1U;
   }
   X2C_PFREE(wfn);
} /* end reqmap() */


static void zoommap(float fzoom, maptool_pIMAGE map)
{
   long yim;
   long yi;
   long mum;
   long mul;
   long bb;
   long gg;
   long rr;
   long y00;
   long y;
   long x;
   float r;
   unsigned long tr;
   struct maptool_PIX * anonym;
   struct maptool_PIX * anonym0;
   struct maptool_PIX * anonym1;
   struct maptool_PIX * anonym2;
   struct maptool_PIX * anonym3;
   struct maptool_PIX * anonym4;
   long tmp;
   long tmp0;
   y00 = (long)((map->Len0-1)+1UL)-(long)X2C_TRUNCI(X2C_DIVR((float)
                ((map->Len0-1)+1UL),fzoom),X2C_min_longint,X2C_max_longint);
   for (x = (long)(map->Len1-1); x>=0L; x--) {
      r = X2C_DIVR((float)x,fzoom);
      tr = aprsdecode_trunc(r);
      mul = (long)X2C_TRUNCI(256.0f*(r-(float)tr),X2C_min_longint,
                X2C_max_longint);
      mum = 256L-mul;
      tmp = y00;
      y = (long)(map->Len0-1);
      if (y>=tmp) for (;; y--) {
         { /* with */
            struct maptool_PIX * anonym = &map->Adr[(tr+1UL)*map->Len0+y];
            rr = (long)anonym->r*mul;
            gg = (long)anonym->g*mul;
            bb = (long)anonym->b*mul;
         }
         { /* with */
            struct maptool_PIX * anonym0 = &map->Adr[(tr)*map->Len0+y];
            rr += (long)anonym0->r*mum;
            gg += (long)anonym0->g*mum;
            bb += (long)anonym0->b*mum;
         }
         { /* with */
            struct maptool_PIX * anonym1 = &map->Adr[(x)*map->Len0+y];
            anonym1->r = (unsigned short)X2C_DIV(rr,256L);
            anonym1->g = (unsigned short)X2C_DIV(gg,256L);
            anonym1->b = (unsigned short)X2C_DIV(bb,256L);
         }
         if (y==tmp) break;
      } /* end for */
   } /* end for */
   tmp = (long)(map->Len0-1);
   y = 0L;
   if (y<=tmp) for (;; y++) {
      r = X2C_DIVR((float)((long)(map->Len0-1)-y),fzoom);
      /*      yi:=VAL(INTEGER,HIGH(map^[0]))-VAL(INTEGER, r);  */
      /*      tr:=TRUNC(r); */
      tr = aprsdecode_trunc(r);
      yi = (long)((map->Len0-1)-tr);
      mul = (long)X2C_TRUNCI(256.0f*(r-(float)tr),X2C_min_longint,
                X2C_max_longint);
      mum = 256L-mul;
      if (yi>0L) yim = yi-1L;
      else yim = 0L;
      tmp0 = (long)(map->Len1-1);
      x = 0L;
      if (x<=tmp0) for (;; x++) {
         { /* with */
            struct maptool_PIX * anonym2 = &map->Adr[(x)*map->Len0+yim];
            rr = (long)anonym2->r*mul;
            gg = (long)anonym2->g*mul;
            bb = (long)anonym2->b*mul;
         }
         { /* with */
            struct maptool_PIX * anonym3 = &map->Adr[(x)*map->Len0+yi];
            rr += (long)anonym3->r*mum;
            gg += (long)anonym3->g*mum;
            bb += (long)anonym3->b*mum;
         }
         { /* with */
            struct maptool_PIX * anonym4 = &map->Adr[(x)*map->Len0+y];
            anonym4->r = (unsigned short)X2C_DIV(rr,256L);
            anonym4->g = (unsigned short)X2C_DIV(gg,256L);
            anonym4->b = (unsigned short)X2C_DIV(bb,256L);
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
} /* end zoommap() */


static unsigned short col(long c)
{
   c += aprsdecode_lums.maplumcorr;
   if (c<0L) c = 0L;
   return (unsigned short)(((unsigned long)c*(unsigned long)
                aprsdecode_lums.map)/256UL);
/*
      RETURN (c)*VAL(CARDINAL,lums.map) DIV 256;
*/
} /* end col() */


static char loadtile(maptool_pIMAGE map, char * done, char dryrun,
                const char h[], unsigned long h_len, const char wfn[],
                unsigned long wfn_len, long dx, long dy, unsigned long doubx,
                 unsigned long douby)
{
   long iy;
   long ix;
   long yy;
   long xx;
   long y;
   long x;
   long maxxbyte;
   long maxy;
   long maxx;
   struct maptool_PIX * anonym;
   struct maptool_PIX * anonym0;
   /*          IF add THEN */
   long tmp;
   long tmp0;
   if (dryrun) {
      if (decodetile(h, h_len, 0, 0L, 0L, 0L)) return 1;
      else {
         *done = 0;
         return 0;
      }
   }
   if (map==0) return 0;
   maxx = 256L;
   maxy = 256L;
   maxxbyte = 768L;
   if (aprsdecode_verb) {
      InOut_WriteString("open>", 6ul);
      InOut_WriteString(h, h_len);
      osi_WrStrLn("<", 2ul);
   }
   /*    IF (pngread.readpng(h, pngbuf, maxx, maxy,
                maxxbyte)<0) OR reloadmap THEN */
   if (!decodetile(h, h_len, (pPNGBUF)pngbuf, 256L, 256L,
                768L) || useri_reloadmap) {
      if (wfn[0]) {
         if ((useri_configon(useri_fGETMAPS) || maptool_mappack.run)
                || useri_reloadmap) reqmap(wfn, wfn_len, !useri_reloadmap);
         *done = 0;
      }
      tmp = (dy+256L)-1L;
      y = dy;
      if (y<=tmp) for (;; y++) {
         tmp0 = (dx+256L)-1L;
         x = dx;
         if (x<=tmp0) for (;; x++) {
            if (((x>=0L && x<(long)((map->Len1-1)+1UL)) && y>=0L) && y<(long)
                ((map->Len0-1)+1UL)) {
               { /* with */
                  struct maptool_PIX * anonym = &map->Adr[(x)*map->Len0+y];
                  anonym->r = 0U;
                  anonym->g = 0U;
                  anonym->b = 0U;
               }
            }
            if (x==tmp0) break;
         } /* end for */
         if (y==tmp) break;
      } /* end for */
      return 0;
   }
   if (doubx>0UL) {
      /* use half zoom tile and double size */
      if (douby==1UL) {
         yy = 0L;
         y = 255L;
         iy = -1L;
      }
      else {
         yy = 128L;
         y = 0L;
         iy = 1L;
      }
      do {
         if (doubx==1UL) {
            xx = 0L;
            x = 255L;
            ix = -1L;
         }
         else {
            xx = 128L;
            x = 0L;
            ix = 1L;
         }
         do {
            pngbuf[y][x] = pngbuf[yy+X2C_DIV(y,2L)][xx+X2C_DIV(x,2L)];
            /*        pngbuf[y]^[x].r8:=255; */
            x += ix;
         } while (!(x<0L || x>255L));
         y += iy;
      } while (!(y<0L || y>255L));
   }
   for (y = 0L; y<=255L; y++) {
      yy = (255L-y)+dy;
      for (x = 0L; x<=255L; x++) {
         xx = x+dx;
         if (((xx>=0L && xx<(long)((map->Len1-1)+1UL)) && yy>=0L)
                && yy<(long)((map->Len0-1)+1UL)) {
            { /* with */
               struct maptool_PIX * anonym0 = &map->Adr[(xx)*map->Len0+yy];
               /*            INC(r, col(pngbuf[y]^[x].r8)); */
               /*            INC(g, col(pngbuf[y]^[x].g8)); */
               /*            INC(b, col(pngbuf[y]^[x].b8)); */
               /*          ELSE */
               anonym0->r = col((long)pngbuf[y][x].r8);
               anonym0->g = col((long)pngbuf[y][x].g8);
               anonym0->b = col((long)pngbuf[y][x].b8);
            }
         }
      } /* end for */
   } /* end for */
   /*          END; */
   return 1;
} /* end loadtile() */


extern void maptool_loadmap(maptool_pIMAGE map, long tx, long ty, long zoom,
                float fzoom, float shftx, float shfty, char * done,
                char * blown, char blow, char dryrun)
{
   long yh;
   long xh;
   long dy;
   long dx;
   long maxtil;
   long y;
   long x;
   char wfn[4096];
   char fnn[4096];
   char ok0;
   long tmp;
   long tmp0;
   *done = 1;
   *blown = 0;
   /*  FILL(map, 0C, SIZE(PIX)*xsize*ysize); */
   maxtil = (long)(aprsdecode_trunc(expzoom(zoom))-1UL);
   yh = X2C_DIV((long)X2C_TRUNCI(X2C_DIVR((float)(map->Len0-1),fzoom)+shfty,
                X2C_min_longint,X2C_max_longint),256L);
   xh = X2C_DIV((long)X2C_TRUNCI(X2C_DIVR((float)(map->Len1-1),fzoom)+shftx,
                X2C_min_longint,X2C_max_longint),256L);
   /*  IF ((tx+1>=maxtil) OR (ty+1>=maxtil)) & NOT dryrun THEN clr(map) END;
                */
   /*  FOR y:=0 TO VAL(INTEGER, FLOAT(HIGH(map^[0]))/fzoom+shfty) DIV TILESIZE DO */
   /*    FOR x:=0 TO VAL(INTEGER,
                FLOAT(HIGH(map^))/fzoom+shftx) DIV TILESIZE DO */
   if ((tx+xh>maxtil || ty+yh>maxtil) && !dryrun) maptool_clr(map);
   tmp = yh;
   y = 0L;
   if (y<=tmp) for (;; y++) {
      tmp0 = xh;
      x = 0L;
      if (x<=tmp0) for (;; x++) {
         if (tx+x<=maxtil && ty+y<=maxtil) {
            mapname(tx+x, ty+y, zoom, fnn, 4096ul, wfn, 4096ul);
            dx = x*256L-(long)X2C_TRUNCI(shftx,X2C_min_longint,
                X2C_max_longint);
            dy = (((long)((map->Len0-1)+1UL)-256L)-y*256L)+(long)
                X2C_TRUNCI(shfty,X2C_min_longint,X2C_max_longint);
            if (((!loadtile(map, done, dryrun, fnn, 4096ul, wfn, 4096ul, dx,
                dy, 0UL, 0UL) && zoom>4L) && !dryrun) && blow) {
               mapname(X2C_DIV(tx+x,2L), X2C_DIV(ty+y,2L), zoom-1L, fnn,
                4096ul, wfn, 4096ul);
               ok0 = loadtile(map, done, dryrun, fnn, 4096ul, "", 1ul, dx,
                dy, (unsigned long)((tx+x&1L)+1L),
                (unsigned long)((ty+y&1L)+1L));
               if (ok0) *blown = 1;
            }
         }
         if (x==tmp0) break;
      } /* end for */
      if (y==tmp) break;
   } /* end for */
   if (!dryrun) {
      if (fzoom>1.0f) zoommap(fzoom, map);
      if (mapnamesbuf[0U]) reqmap("", 1ul, !useri_reloadmap);
      else FileSys_Remove("gettiles", 9ul, &ok0);
   }
   useri_reloadmap = 0;
} /* end loadmap() */


extern char maptool_IsMapLoaded(void)
{
   return !aprsdecode_maploadpid.runs || !FileSys_Exists("gettiles", 9ul);
} /* end IsMapLoaded() */


static void margin(long * ty1, long * tx1, long * ty0, long * tx0, long * z)
{
   long maxtil;
   float py;
   float px;
   struct maptool__D0 * anonym;
   { /* with */
      struct maptool__D0 * anonym = &maptool_mappack;
      maptool_mercator(anonym->leftup.long0, anonym->leftup.lat, *z, tx0,
                ty0, &px, &py);
      maptool_mercator(anonym->rightdown.long0, anonym->rightdown.lat, *z,
                tx1, ty1, &px, &py);
      maxtil = (long)(aprsdecode_trunc(expzoom(*z))-1UL);
      if (*tx0>maxtil) *tx0 = maxtil;
      if (*tx1>maxtil) *tx1 = maxtil;
      if (*ty0>maxtil) *ty0 = maxtil;
      if (*ty1>maxtil) *ty1 = maxtil;
   }
} /* end margin() */


static char inc(long * x, long * y, long * z)
{
   long ty1;
   long ty0;
   long tx1;
   long tx0;
   if (*z==0L) {
      *z = 1L;
      margin(&ty1, &tx1, &ty0, &tx0, z);
      *x = tx0;
      *y = ty0;
   }
   else {
      margin(&ty1, &tx1, &ty0, &tx0, z);
      ++*x;
      if (*x>tx1) {
         *x = tx0;
         ++*y;
         if (*y>ty1) {
            ++*z;
            if (*z>maptool_mappack.tozoom) return 0;
            margin(&ty1, &tx1, &ty0, &tx0, z);
            *x = tx0;
            *y = ty0;
         }
      }
   }
   return 1;
} /* end inc() */


static char checktile(char fn[], unsigned long fn_len)
{
   long maxxbyte;
   long maxy;
   long maxx;
   char checktile_ret;
   X2C_PCOPY((void **)&fn,fn_len);
   maxx = 256L;
   maxy = 256L;
   maxxbyte = 768L;
   /*    RETURN pngread.readpng(fn, pngbuf, maxx, maxy, maxxbyte)>=0 */
   checktile_ret = decodetile(fn, fn_len, (pPNGBUF)pngbuf, 256L, 256L, 768L);
                
   X2C_PFREE(fn);
   return checktile_ret;
} /* end checktile() */

#define maptool_MAXREQ 10

#define maptool_MAXRETRYS 10

#define maptool_MAXLOOKUP 500000


extern void maptool_MapPackageJob(char dryrun)
{
   long z;
   long y;
   long x;
   char rfn[4096];
   char fn[4096];
   unsigned long rcnt;
   struct maptool__D0 * anonym;
   { /* with */
      struct maptool__D0 * anonym = &maptool_mappack;
      if (dryrun) {
         do {
            if (anonym->zoom>0L) {
               /* zoom 0 is init */
               mapname(anonym->tx, anonym->ty, anonym->zoom, fn, 4096ul, rfn,
                 4096ul);
               if (!decodetile(fn, 4096ul, 0, 0L, 0L, 0L)) {
                  ++anonym->needcnt;
                  if (anonym->needcnt>500000UL) {
                     anonym->overflow = 1; /* to long calculation time */
                  }
               }
               ++anonym->mapscnt;
            }
         } while (!(!inc(&anonym->tx, &anonym->ty, &anonym->zoom) || anonym->overflow));
         return;
      }
      if (!anonym->run) return;
      if (anonym->delay+1UL<anonym->retrys*anonym->retrys) {
         ++anonym->delay; /* increasing delay */
         return;
      }
      anonym->delay = 0UL;
      if (maptool_IsMapLoaded()) {
         /* check what have */
         /*WrStrLn("gettiles deleted"); */
         for (;;) {
            if (anonym->zoom>0L) {
               /* zoom 0 is init */
               mapname(anonym->tx, anonym->ty, anonym->zoom, fn, 4096ul, rfn,
                 4096ul);
               if (!checktile(fn, 4096ul)) {
                  if (anonym->retrys<10UL) break;
                  ++anonym->givups;
               }
               ++anonym->donecnt;
               anonym->retrys = 0UL;
            }
            if (!inc(&anonym->tx, &anonym->ty, &anonym->zoom)) {
               anonym->run = 0;
               useri_downloadprogress(); /* say end of job */
               return;
            }
         }
         /* all done */
         useri_downloadprogress();
         rcnt = 0UL;
         x = anonym->tx;
         y = anonym->ty;
         z = anonym->zoom;
         do {
            mapname(x, y, z, fn, 4096ul, rfn, 4096ul);
            if (!checktile(fn, 4096ul)) {
               reqmap(rfn, 4096ul, 0);
               ++rcnt;
            }
         } while (!(!inc(&x, &y, &z) || rcnt>=10UL));
         /* last map */
         reqmap("", 1ul, 0); /* flush request buffer */
         if (anonym->retrys>0UL) ++anonym->retrysum;
         ++anonym->retrys;
      }
   }
} /* end MapPackageJob() */


extern void maptool_StartMapPackage(struct aprspos_POSITION lu,
                struct aprspos_POSITION rd, long tillzoom, char dryrun)
{
   struct maptool__D0 * anonym;
   memset((char *) &maptool_mappack,(char)0,sizeof(struct maptool__D0));
   { /* with */
      struct maptool__D0 * anonym = &maptool_mappack;
      anonym->leftup = lu;
      anonym->rightdown = rd;
      anonym->tozoom = tillzoom;
      anonym->run = !dryrun;
   }
   if (dryrun) maptool_MapPackageJob(1);
} /* end StartMapPackage() */

typedef struct PIX8 * pROWS1;


static void loadsym(char h[], unsigned long h_len)
{
   unsigned long y;
   unsigned long x;
   pROWS1 rows[16];
   long res;
   long maxxbyte;
   long maxy;
   long maxx;
   char bu[16][9216];
   struct PIX8 * anonym;
   X2C_PCOPY((void **)&h,h_len);
   for (y = 0UL; y<=15UL; y++) {
      rows[y] = (pROWS1) &bu[y][0U];
   } /* end for */
   maxx = 3072L;
   maxy = 16L;
   maxxbyte = maxx*3L;
   res = readpng(h, (X2C_ADDRESS *)rows, &maxx, &maxy, &maxxbyte);
   if (res<0L) {
      InOut_WriteInt(res, 1UL);
      osi_WrStrLn(" symbol file read error", 24ul);
      goto label;
   }
   memset((char *)symbols,(char)0,sizeof(struct PIX8 [3072][17]));
   for (y = 0UL; y<=15UL; y++) {
      for (x = 0UL; x<=3071UL; x++) {
         { /* with */
            struct PIX8 * anonym = &symbols[x][15UL-y];
            anonym->r8 = rows[y][x].r8;
            anonym->g8 = rows[y][x].g8;
            anonym->b8 = rows[y][x].b8;
         }
      } /* end for */
   } /* end for */
   label:;
   X2C_PFREE(h);
} /* end loadsym() */


static float sinc(float x, unsigned long w)
/* sin(x)/x with hann windown */
{
   float win;
   if ((float)fabs(x)<0.001f) return 1.0f;
   win = X2C_DIVR(3.1415926535f*x,(float)w);
   x = x*3.1415926535f;
   return (float)(X2C_DIVL((X2C_DIVL(sin((double)x),
                (double)x))*sin((double)win),(double)win));
} /* end sinc() */

#define maptool_MAXY 24
/* font image max y size */

#define maptool_MAXX 600
/* font image max x size */

#define maptool_CHARX 6
/* chars x size pixel */

#define maptool_MINWIDTH 3

#define maptool_GARBAGE 500
/* sum of pixels outside y font image */

#define maptool_FIRLEN 3

typedef char * pROWS;


extern void maptool_loadfont(void)
{
   unsigned long higth;
   unsigned long i;
   unsigned long fonty;
   unsigned long y1;
   unsigned long y00;
   unsigned long xshift;
   unsigned long y;
   unsigned long x;
   unsigned long c;
   unsigned short m;
   long res;
   long maxxbyte;
   long maxy;
   long maxx;
   pROWS rows[24];
   char bu[24][600];
   unsigned long xhist[6];
   unsigned long yhist[24];
   float fir[31];
   float yr;
   float sum;
   unsigned long nin;
   char fn[1025];
   struct _0 * anonym;
   unsigned long tmp;
   unsigned long tmp0;
   higth = (unsigned long)useri_conf2int(useri_fFONTSIZE, 0UL, 7L, 18L, 10L);
   memset((char *)font,(char)0,sizeof(struct _0 [97]));
   for (y = 0UL; y<=23UL; y++) {
      rows[y] = (pROWS) &bu[y][0U];
   } /* end for */
   maxx = 600L;
   maxy = 24L;
   maxxbyte = maxx;
   strncpy(fn,"font.png",1025u);
   res = readpng(fn, (X2C_ADDRESS *)rows, &maxx, &maxy, &maxxbyte);
   if ((((res<0L || maxx<1L) || maxx>600L) || maxy<1L) || maxy>24L) {
      InOut_WriteInt(res, 1UL);
      osi_WrStrLn(" fontfile read error", 21ul);
      aprsdecode_lums.fontysize = higth+3UL;
      return;
   }
   for (x = 0UL; x<=5UL; x++) {
      xhist[x] = 0UL;
   } /* end for */
   for (y = 0UL; y<=23UL; y++) {
      yhist[y] = 0UL;
   } /* end for */
   tmp = (unsigned long)(maxx-1L);
   x = 0UL;
   if (x<=tmp) for (;; x++) {
      /* make column histogram to find char position in font file */
      tmp0 = (unsigned long)(maxy-1L);
      y = 0UL;
      if (y<=tmp0) for (;; y++) {
         xhist[x%6UL] += (unsigned long)(unsigned char)rows[y][x];
         yhist[y] += (unsigned long)(unsigned char)rows[y][x];
         if (y==tmp0) break;
      } /* end for */
      if (x==tmp) break;
   } /* end for */
   c = X2C_max_longcard;
   for (x = 0UL; x<=5UL; x++) {
      if (xhist[x]<c) {
         c = xhist[x]; /* find space between chars */
         xshift = x;
      }
   } /* end for */
   y00 = 0UL;
   y1 = 0UL;
   for (y = 0UL; y<=23UL; y++) {
      /* find y position and size */
      if (yhist[y]>500UL) {
         if (y00==0UL) y00 = y;
         y1 = y;
      }
   } /* end for */
   if (y1<y00+4UL) {
      osi_WrStrLn(" font too small error", 22ul);
      return;
   }
   /*
     fonty:=y1-y0+3;
     IF fonty>MAXFONTY THEN
       WrStrLn(" font too high");
       fonty:=MAXFONTY; 
     END;
   */
   nin = (y1-y00)+1UL;
   /*WrInt(y0, 10); WrInt(y1, 10); WrLn; */
   fonty = higth+3UL;
   for (y = 0UL; y<=30UL; y++) {
      fir[y] = 0.0f;
   } /* end for */
   for (x = 0UL; x<=581UL; x++) {
      tmp = nin-1UL;
      y = 0UL;
      if (y<=tmp) for (;; y++) {
         fir[y+3UL] = (float)(unsigned long)(unsigned char)
                rows[y00+y][x+xshift];
         if (y==tmp) break;
      } /* end for */
      /*FOR y:=0 TO HIGH(fir) DO WrInt(trunc(fir[y]), 8); END; WrLn; */
      tmp = higth-1UL;
      y = 0UL;
      if (y<=tmp) for (;; y++) {
         if (higth!=nin) {
            yr = X2C_DIVR((float)(y*nin),(float)higth);
            sum = 0.0f;
            for (i = 1UL; i<=6UL; i++) {
               sum = sum+sinc(((float)i-3.0f)-(yr-(float)aprsdecode_trunc(yr)
                ), 3UL)*fir[i+aprsdecode_trunc(yr)];
            } /* end for */
         }
         else sum = fir[y+3UL];
         if (sum<=0.0f) c = 0UL;
         else if (sum>255.9f) c = 255UL;
         else c = aprsdecode_trunc(sum);
         font[x/6UL].char0[(fonty-y)-3UL][x%6UL] = (unsigned char)c;
         if (y==tmp) break;
      } /* end for */
   } /* end for */
   /*
     FOR y:=0 TO fonty-3 DO
       FOR x:=0 TO CHARS*CHARX-1 DO
         WITH font[x DIV CHARX] DO char[fonty-y-3][x MOD 6]:=ORD(rows[y0+y]
                ^[x+xshift]) END;
       END; 
     END;
   */
   aprsdecode_lums.fontysize = fonty;
   for (c = 0UL; c<=96UL; c++) {
      { /* with */
         struct _0 * anonym = &font[c];
         anonym->width = 3U;
         tmp = fonty-3UL;
         y = 0UL;
         if (y<=tmp) for (;; y++) {
            for (x = 0UL; x<=7UL; x++) {
               if (anonym->char0[y][x]>=128U) {
                  if (c) {
                     m = X2C_LSH(0x1FU,16,(long)x-1L)&0xFEU;
                     anonym->mask[y] = anonym->mask[y]|m;
                     if (y+1UL<=20UL) {
                        anonym->mask[y+1UL] = anonym->mask[y+1UL]|m;
                     }
                     if (y+2UL<=20UL) {
                        anonym->mask[y+2UL] = anonym->mask[y+2UL]|m;
                     }
                  }
                  if (x>(unsigned long)anonym->width) {
                     anonym->width = (unsigned char)x;
                  }
               }
            } /* end for */
            if (y==tmp) break;
         } /* end for */
      }
   } /* end for */
} /* end loadfont() */

#define maptool_BMPHLEN 54


static void numh(char h[256], unsigned long n, unsigned long pos,
                unsigned long size)
{
   unsigned long i;
   unsigned long tmp;
   tmp = size-1UL;
   i = 0UL;
   if (i<=tmp) for (;; i++) {
      h[pos+i] = (char)(n&255UL);
      n = n/256UL;
      if (i==tmp) break;
   } /* end for */
} /* end numh() */


static void wr(long fd, unsigned long * len, char b[32768],
                unsigned short c)
{
   if (c<=1023U) b[*len] = gammatab[c];
   else b[*len] = '\377';
   ++*len;
   if (*len>32767UL) {
      osi_WrBin(fd, (char *)b, 32768u/1u, *len);
      *len = 0UL;
   }
} /* end wr() */


static unsigned char pngc(unsigned short c)
{
   if (c<=1023U) return gammatab[c];
   else return 255U;
   return 0;
} /* end pngc() */


extern long maptool_saveppm(char fn[], unsigned long fn_len,
                maptool_pIMAGE image, long xsize, long ysize)
{
   long fd;
   char h[256];
   long y;
   long x;
   char b[32768];
   unsigned long len;
   struct PNGPIXMAP pngimg;
   long ret;
   struct maptool_PIX * anonym;
   struct maptool_PIX * anonym0;
   struct PNGPIXEL * anonym1;
   struct maptool_PIX * anonym2;
   long tmp;
   long tmp0;
   long maptool_saveppm_ret;
   X2C_PCOPY((void **)&fn,fn_len);
   aprsstr_cleanfilename(fn, fn_len);
   fd = osi_OpenWrite(fn, fn_len);
   if (!osi_FdValid(fd)) {
      InOut_WriteString(fn, fn_len);
      osi_WrStrLn(" not writeable", 15ul);
      maptool_saveppm_ret = -1L;
      goto label;
   }
   len = aprsstr_Length(fn, fn_len); /* check fn if ppm or bmp */
   if ((((len>=4UL && fn[len-4UL]=='.') && X2C_CAP(fn[len-3UL])=='B')
                && X2C_CAP(fn[len-2UL])=='M') && X2C_CAP(fn[len-1UL])=='P') {
      /* make BMP */
      memset((char *)h,(char)0,256UL);
      h[0U] = 'B';
      h[1U] = 'M';
      numh(h, (unsigned long)(X2C_DIV(xsize*3L+4L,4L)*4L*ysize+54L), 2UL,
                4UL); /* file len pad lines to x4 byte */
      numh(h, 54UL, 10UL, 4UL); /* headerlen */
      numh(h, 40UL, 14UL, 4UL); /* DWORD   biSize */
      numh(h, (unsigned long)xsize, 18UL, 4UL); /* LONG    biWidth */
      numh(h, (unsigned long)ysize, 22UL, 4UL); /* LONG    biHeight */
      numh(h, 1UL, 26UL, 2UL); /* WORD    biPlanes */
      numh(h, 24UL, 28UL, 2UL); /* WORD    biBitCount */
      numh(h, 0UL, 30UL, 4UL); /* DWORD   biCompression */
      osi_WrBin(fd, (char *)h, 256u/1u, 54UL);
      len = 0UL;
      tmp = ysize-1L;
      y = 0L;
      if (y<=tmp) for (;; y++) {
         tmp0 = xsize-1L;
         x = 0L;
         if (x<=tmp0) for (;; x++) {
            { /* with */
               struct maptool_PIX * anonym = &image->Adr[(x)*image->Len0+y];
               wr(fd, &len, b, anonym->b);
               wr(fd, &len, b, anonym->g);
               wr(fd, &len, b, anonym->r);
            }
            if (x==tmp0) break;
         } /* end for */
         while (len&3UL) wr(fd, &len, b, 0U);
         if (y==tmp) break;
      } /* end for */
      if (len>0UL) osi_WrBin(fd, (char *)b, 32768u/1u, len);
      osi_Close(fd);
      ret = 0L;
   }
   else if ((((len>=4UL && fn[len-4UL]=='.') && X2C_CAP(fn[len-3UL])=='P')
                && X2C_CAP(fn[len-2UL])=='N') && X2C_CAP(fn[len-1UL])=='G') {
      /* make PNG */
      ret = -1L;
      osi_Close(fd);
      Storage_ALLOCATE((X2C_ADDRESS *) &pngimg.image,
                (unsigned long)(xsize*ysize*3L));
      if (pngimg.image) {
         tmp = ysize-1L;
         y = 0L;
         if (y<=tmp) for (;; y++) {
            tmp0 = xsize-1L;
            x = 0L;
            if (x<=tmp0) for (;; x++) {
               { /* with */
                  struct maptool_PIX * anonym0 = &image->Adr[(x)
                *image->Len0+((ysize-1L)-y)];
                  { /* with */
                     struct PNGPIXEL * anonym1 = &pngimg.image[x+y*xsize];
                     anonym1->red = pngc(anonym0->r);
                     anonym1->green = pngc(anonym0->g);
                     anonym1->blue = pngc(anonym0->b);
                  }
               }
               if (x==tmp0) break;
            } /* end for */
            if (y==tmp) break;
         } /* end for */
         pngimg.width = (unsigned long)xsize;
         pngimg.height = (unsigned long)ysize;
         ret = writepng(fn, &pngimg);
         Storage_DEALLOCATE((X2C_ADDRESS *) &pngimg.image,
                (unsigned long)(xsize*ysize*3L));
      }
      else osi_WrStrLn("png write out of memory", 24ul);
   }
   else {
      /* ppm header */
      strncpy(h,"P6\012",256u);
      osi_WrBin(fd, (char *)h, 256u/1u, aprsstr_Length(h, 256ul));
      aprsstr_IntToStr(xsize, 1UL, h, 256ul);
      osi_WrBin(fd, (char *)h, 256u/1u, aprsstr_Length(h, 256ul));
      strncpy(h," ",256u);
      osi_WrBin(fd, (char *)h, 256u/1u, aprsstr_Length(h, 256ul));
      aprsstr_IntToStr(ysize, 1UL, h, 256ul);
      osi_WrBin(fd, (char *)h, 256u/1u, aprsstr_Length(h, 256ul));
      strncpy(h,"\012255\012",256u);
      osi_WrBin(fd, (char *)h, 256u/1u, aprsstr_Length(h, 256ul));
      len = 0UL;
      for (y = ysize-1L; y>=0L; y--) {
         tmp = xsize-1L;
         x = 0L;
         if (x<=tmp) for (;; x++) {
            { /* with */
               struct maptool_PIX * anonym2 = &image->Adr[(x)*image->Len0+y];
                
               wr(fd, &len, b, anonym2->r);
               wr(fd, &len, b, anonym2->g);
               wr(fd, &len, b, anonym2->b);
            }
            if (x==tmp) break;
         } /* end for */
      } /* end for */
      if (len>0UL) osi_WrBin(fd, (char *)b, 32768u/1u, len);
      osi_Close(fd);
      ret = 0L;
   }
   maptool_saveppm_ret = ret;
   label:;
   X2C_PFREE(fn);
   return maptool_saveppm_ret;
} /* end saveppm() */


extern void maptool_allocimage(maptool_pIMAGE * image, long x, long y)
{
   size_t tmp[2];
   /*WrInt(x, 6); WrInt(y, 6); WrStrLn(" allocimage"); */
   if (*image) {
      useri_debugmem.screens -= (*image)->Len1*(*image)->Size1;
      X2C_DYNDEALLOCATE((char **)image);
   }
   X2C_DYNALLOCATE((char **)image,sizeof(struct maptool_PIX),
                (tmp[0] = (size_t)x,tmp[1] = (size_t)y,tmp),2u);
   useri_debugmem.req = (unsigned long)((long)sizeof(struct maptool_PIX)*x*y)
                ;
   useri_debugmem.screens += useri_debugmem.req;
   if (*image==0) {
      osi_WrStrLn("image out of memory", 20ul);
      useri_wrheap();
      X2C_ABORT();
   }
   if (aprsdecode_verb) useri_wrheap();
} /* end allocimage() */


static void allocpngbuf(void)
{
   unsigned long i;
   for (i = 0UL; i<=255UL; i++) {
      Storage_ALLOCATE((char **) &pngbuf[i], sizeof(ROWS0));
      useri_debugmem.req = sizeof(pROWS0);
      useri_debugmem.screens += useri_debugmem.req;
      if (pngbuf[i]==0) {
         osi_WrStrLn("pngbuf out of memory", 21ul);
         useri_wrheap();
         X2C_ABORT();
      }
   } /* end for */
} /* end allocpngbuf() */


extern void maptool_BEGIN(void)
{
   static int maptool_init = 0;
   if (maptool_init) return;
   maptool_init = 1;
   if (sizeof(FN)!=1024) X2C_ASSERT(0);
   aprstext_BEGIN();
   useri_BEGIN();
   Storage_BEGIN();
   TimeConv_BEGIN();
   xosi_BEGIN();
   osi_BEGIN();
   aprspos_BEGIN();
   aprsstr_BEGIN();
   aprsdecode_BEGIN();
   aprsdecode_maploadpid.runs = 0;
   maploadstart = 0UL;
   loadsym("symbols.png", 12ul);
   /*  loadfont; */
   makegammatab();
   allocpngbuf();
   mapnamesbuf[0U] = 0;
   mapnamesdone = 0U;
   maploopcnt = 0UL;
   lastmapreq = 0UL;
   mapdelay = 0UL;
   srtmcache.fd = -1L;
}

