/* "@(#)udphub.c Oct  9  0:05:24 2013" */
/* Generated by XDS Modula-2 to ANSI C v4.20 translator */

#define X2C_int32
#define X2C_index32
#ifndef X2C_H_
#include "X2C.h"
#endif
#define udphub_C_
#ifndef Storage_H_
#include "Storage.h"
#endif
#ifndef osi_H_
#include "osi.h"
#endif
#ifndef Lib_H_
#include "Lib.h"
#endif
#ifndef InOut_H_
#include "InOut.h"
#endif
#ifndef udp_H_
#include "udp.h"
#endif
#ifndef Select_H_
#include "Select.h"
#endif
#ifndef TimeConv_H_
#include "TimeConv.h"
#endif

/* axudp bidirectional digi - user hub by OE5DXL */
/*
FROM FIO IMPORT OpenMode, Close, oRDONLY, oAPPEND, oWRONLY, oNONBLOCK,
                Create, WrBin, RdBin, File;
*/
#define udphub_CALLLEN 7

#define udphub_MAXLEN 338

#define udphub_MINLEN 17

static unsigned long udphub_POLYNOM = 0x8408UL;

static unsigned long udphub_CRCINIT = 0xFFFFUL;

#define udphub_SOURCECALL 7

#define udphub_DESTCALL 0

#define udphub_MAXFD 31

typedef char RAWCALL[7];


struct TIMEVAL {
   long tvsec;
   long tvusec;
};

struct USER;

typedef struct USER * pUSER;


struct USER {
   pUSER next;
   RAWCALL call;
   unsigned long uip;
   unsigned long dport;
   unsigned long htime;
};

static unsigned char CRCL[256];

static unsigned char CRCH[256];

static char show;

static char checkdigiip;

static pUSER users;

static unsigned long systime;

static unsigned long lifetime;

static unsigned long touserport;

static unsigned long todigiport;

static unsigned long digiip;

static long digisock;

static long usersock;

static unsigned long maxentries;

/*
PROCEDURE ["C"] / select(n: INTEGER; readfds: ADDRESS; writefds: ADDRESS;
                         exceptfds: ADDRESS; timeout: ADDRESS) : INTEGER;
*/

static void Err(const char text[], unsigned long text_len)
{
   InOut_WriteString("udphub: ", 9ul);
   InOut_WriteString(text, text_len);
   osi_WrStrLn(" error abort", 13ul);
   X2C_ABORT();
} /* end Err() */

#define udphub_POLINOM 0x8408 


static void Gencrctab(void)
{
   unsigned long c;
   unsigned long crc;
   unsigned long i;
   for (c = 0UL; c<=255UL; c++) {
      crc = 255UL-c;
      for (i = 0UL; i<=7UL; i++) {
         if ((crc&1)) {
            crc = (unsigned long)((unsigned long)(crc>>1)^0x8408UL);
         }
         else crc = crc>>1;
      } /* end for */
      CRCL[c] = (unsigned char)crc;
      CRCH[c] = (unsigned char)(255UL-(crc>>8));
   } /* end for */
} /* end Gencrctab() */


static char testCRC(char frame[], unsigned long frame_len, long size)
{
   unsigned char h;
   unsigned char l;
   unsigned char b;
   long i;
   long tmp;
   l = 0U;
   h = 0U;
   tmp = size-3L;
   i = 0L;
   if (i<=tmp) for (;; i++) {
      b = (unsigned char)((unsigned char)(unsigned char)frame[i]^l);
      l = CRCL[b]^h;
      h = CRCH[b];
      if (i==tmp) break;
   } /* end for */
   return frame[size-2L]==(char)l && frame[size-1L]==(char)h;
} /* end testCRC() */


static long getudp(long fd, char buf[], unsigned long buf_len,
                unsigned long * fromip0, unsigned long * fromport,
                char checkip)
{
   unsigned long ip;
   long len;
   len = udpreceive(fd, buf, (long)(buf_len), fromport, &ip);
   if (len<2L || !testCRC(buf, buf_len, len)) {
      if (show) osi_WrStrLn(" axudp crc error ", 18ul);
      return -1L;
   }
   if (checkip && *fromip0!=ip) return -2L;
   *fromip0 = ip;
   return len;
} /* end getudp() */


static char Call2Str(const char r[], unsigned long r_len, char t[],
                unsigned long t_len, unsigned long pos, unsigned long * len)
{
   unsigned long ssid;
   unsigned long e;
   unsigned long i;
   char c;
   unsigned long tmp;
   e = pos;
   tmp = pos+5UL;
   i = pos;
   if (i<=tmp) for (;; i++) {
      if (r[i]!='@') e = i;
      if (i==tmp) break;
   } /* end for */
   tmp = e;
   i = pos;
   if (i<=tmp) for (;; i++) {
      c = (char)((unsigned long)(unsigned char)r[i]>>1);
      if ((unsigned char)c<=' ') {
         t[*len] = 0;
         *len = 0UL;
         return 0;
      }
      t[*len] = c;
      ++*len;
      if (i==tmp) break;
   } /* end for */
   ssid = (unsigned long)(unsigned char)r[pos+6UL]>>1&15UL;
   if (ssid>0UL) {
      t[*len] = '-';
      ++*len;
      if (ssid>9UL) {
         t[*len] = '1';
         ++*len;
      }
      t[*len] = (char)(ssid%10UL+48UL);
      ++*len;
   }
   return 1;
} /* end Call2Str() */


static long GetIp(char h[], unsigned long h_len, unsigned long * ip,
                unsigned long * dp, unsigned long * lp, long * fd,
                char * check)
{
   unsigned long p;
   unsigned long n;
   unsigned long i;
   char ok0;
   long GetIp_ret;
   X2C_PCOPY((void **)&h,h_len);
   p = 0UL;
   h[h_len-1] = 0;
   *ip = 0UL;
   for (i = 0UL; i<=5UL; i++) {
      n = 0UL;
      ok0 = 0;
      while ((unsigned char)h[p]>='0' && (unsigned char)h[p]<='9') {
         ok0 = 1;
         n = (n*10UL+(unsigned long)(unsigned char)h[p])-48UL;
         ++p;
      }
      if (!ok0) {
         GetIp_ret = -1L;
         goto label;
      }
      if (i<3UL) {
         if (h[p]!='.' || n>255UL) {
            GetIp_ret = -1L;
            goto label;
         }
         *ip =  *ip*256UL+n;
      }
      else if (i==3UL) {
         *ip =  *ip*256UL+n;
         if (h[p]!=':' || n>255UL) {
            GetIp_ret = -1L;
            goto label;
         }
      }
      else if (i==4UL) {
         *check = h[p]!='/';
         if (h[p]!=':' && h[p]!='/' || n>65535UL) {
            GetIp_ret = -1L;
            goto label;
         }
         *dp = n;
      }
      else if (n>65535UL) {
         GetIp_ret = -1L;
         goto label;
      }
      *lp = n;
      ++p;
   } /* end for */
   *fd = openudp();
   if (*fd<0L || bindudp(*fd, *lp)<0L) {
      /*OR (udp.udpnonblock(fd)<0)*/
      GetIp_ret = -1L;
      goto label;
   }
   GetIp_ret = 0L;
   label:;
   X2C_PFREE(h);
   return GetIp_ret;
} /* end GetIp() */


static char GetNum(const char h[], unsigned long h_len, unsigned long * n)
{
   unsigned long i;
   *n = 0UL;
   i = 0UL;
   while ((unsigned char)h[i]>='0' && (unsigned char)h[i]<='9') {
      *n = ( *n*10UL+(unsigned long)(unsigned char)h[i])-48UL;
      ++i;
   }
   return h[i]==0;
} /* end GetNum() */


static void parms(void)
{
   char err;
   char h[1024];
   unsigned long i;
   unsigned long fromdigiport;
   err = 0;
   for (;;) {
      Lib_NextArg(h, 1024ul);
      if (h[0U]==0) break;
      if ((h[0U]=='-' && h[1U]) && h[2U]==0) {
         if (h[1U]=='l') {
            Lib_NextArg(h, 1024ul);
            if (!GetNum(h, 1024ul, &i)) Err("-l minutes", 11ul);
            lifetime = i*60UL;
         }
         else if (h[1U]=='m') {
            Lib_NextArg(h, 1024ul);
            if (!GetNum(h, 1024ul, &maxentries)) Err("-m number", 10ul);
         }
         else if (h[1U]=='p') {
            Lib_NextArg(h, 1024ul);
            if (!GetNum(h, 1024ul, &touserport)) Err("-p portnumber", 14ul);
         }
         else if (h[1U]=='u') {
            Lib_NextArg(h, 1024ul);
            if (GetIp(h, 1024ul, &digiip, &todigiport, &fromdigiport,
                &digisock, &checkdigiip)<0L) {
               Err("cannot open digi udp socket", 28ul);
            }
         }
         else if (h[1U]=='v') show = 1;
         else {
            if (h[1U]=='h') {
               osi_WrLn();
               osi_WrStrLn(" -l <time>                         minutes lifeti\
me (default 1 week)", 69ul);
               osi_WrStrLn(" -m <maxentries>                   else delete ol\
d entries (default 1000)", 74ul);
               osi_WrStrLn(" -p <userport>                     udp port for u\
sers", 54ul);
               osi_WrStrLn(" -u <x.x.x.x:destport:listenport>  axudp to digi \
/listenport no check ip", 73ul);
               osi_WrStrLn(" -v                                verbous",
                43ul);
               osi_WrStrLn(" -h                                this", 40ul);
               osi_WrLn();
               X2C_ABORT();
            }
            err = 1;
         }
      }
      else {
         /*
               h[0]:=0C;
         */
         err = 1;
      }
      if (err) break;
   }
   if (err) {
      InOut_WriteString(">", 2ul);
      InOut_WriteString(h, 1024ul);
      osi_WrStrLn("< use -h", 9ul);
      X2C_ABORT();
   }
} /* end parms() */


static void showpip(unsigned long ip, unsigned long port)
{
   InOut_WriteInt((long)(ip/16777216UL), 1UL);
   InOut_WriteString(".", 2ul);
   InOut_WriteInt((long)(ip/65536UL&255UL), 1UL);
   InOut_WriteString(".", 2ul);
   InOut_WriteInt((long)(ip/256UL&255UL), 1UL);
   InOut_WriteString(".", 2ul);
   InOut_WriteInt((long)(ip&255UL), 1UL);
   InOut_WriteString(":", 2ul);
   InOut_WriteInt((long)port, 1UL);
} /* end showpip() */


static void showcall(const char b[], unsigned long b_len,
                unsigned long start)
{
   char h[16];
   unsigned long l;
   l = 0UL;
   if (Call2Str(b, b_len, h, 16ul, start, &l)) {
      h[l] = 0;
      InOut_WriteString(h, 16ul);
   }
} /* end showcall() */


static void showframe(const char s[], unsigned long s_len, const char b[],
                unsigned long b_len)
{
   InOut_WriteString(s, s_len);
   showcall(b, b_len, 7UL);
   InOut_WriteString(">", 2ul);
   showcall(b, b_len, 0UL);
   osi_WrLn();
} /* end showframe() */


static char cmpcall(const RAWCALL c, const char b[], unsigned long b_len,
                unsigned long start)
{
   unsigned long i;
   for (i = 0UL; i<=5UL; i++) {
      if (c[i]!=b[i+start]) return 0;
   } /* end for */
   return ((unsigned long)(unsigned char)c[6U]/2UL&15UL)==((unsigned long)
                (unsigned char)b[start+6UL]/2UL&15UL);
} /* end cmpcall() */


static pUSER Realloc(void)
{
   unsigned long cnt;
   pUSER new0;
   pUSER last;
   pUSER u;
   cnt = 0UL;
   last = 0;
   new0 = 0;
   u = users;
   for (;;) {
      if (u==0) break;
      if (u->htime+lifetime<systime || cnt>=maxentries) {
         /* old oder too much entries */
         if (last==0) users = 0;
         else last->next = 0;
         do {
            /* free rest of chain */
            last = u;
            u = u->next;
            if (new0==0) new0 = last;
            else {
               Storage_DEALLOCATE((X2C_ADDRESS *) &last,
                sizeof(struct USER));
            }
         } while (u);
         break;
      }
      last = u;
      u = u->next;
      ++cnt;
   }
   if (new0==0) Storage_ALLOCATE((X2C_ADDRESS *) &new0, sizeof(struct USER));
   if (show) {
      InOut_WriteString(" Table entries=", 16ul);
      InOut_WriteInt((long)cnt, 1UL);
      osi_WrLn();
   }
   return new0;
} /* end Realloc() */


static void AddIp(unsigned long ip, unsigned long dp, const char buf[],
                unsigned long buf_len)
{
   pUSER last;
   pUSER u;
   unsigned long i;
   /* for fast find, rechain to first position*/
   struct USER * anonym;
   struct USER * anonym0;
   u = users;
   last = 0;
   while (u) {
      if (cmpcall(u->call, buf, buf_len, 7UL)) {
         if (last) {
            last->next = u->next;
            u->next = users;
            users = u;
         }
         { /* with */
            struct USER * anonym = u;
            anonym->htime = systime;
            anonym->uip = ip; /* store if ip changed */
            anonym->dport = dp;
         }
         if (show) {
            InOut_WriteString("Found User ", 12ul);
            showcall(buf, buf_len, 7UL);
            InOut_WriteString(" IP:", 5ul);
            showpip(u->uip, dp);
            osi_WrLn();
         }
         return;
      }
      last = u;
      u = u->next;
   }
   if (u==0) {
      if (show) {
         InOut_WriteString("Add User ", 10ul);
         showcall(buf, buf_len, 7UL);
         InOut_WriteString(" IP:", 5ul);
         showpip(ip, dp);
         osi_WrLn();
      }
      u = Realloc();
      if (u==0) {
         if (show) osi_WrStrLn(" user add out of memory", 24ul);
      }
      else {
         { /* with */
            struct USER * anonym0 = u;
            for (i = 0UL; i<=6UL; i++) {
               anonym0->call[i] = buf[7UL+i];
            } /* end for */
            anonym0->call[6U] = (char)(((unsigned long)(unsigned char)
                anonym0->call[6U]/2UL&15UL)*2UL); /* extract pure ssid */
            anonym0->uip = ip;
            anonym0->dport = dp;
            anonym0->htime = systime;
         }
         u->next = users;
         users = u;
      }
   }
} /* end AddIp() */


static char FindIp(unsigned long * toip0, unsigned long * toport,
                const char buf[], unsigned long buf_len)
{
   pUSER u;
   u = users;
   while (u) {
      if (cmpcall(u->call, buf, buf_len, 0UL)) {
         *toip0 = u->uip;
         *toport = u->dport;
         return 1;
      }
      u = u->next;
   }
   return 0;
} /* end FindIp() */

static char ubuf[338];

static long blen;

static long res;

static unsigned long fromip;

static unsigned long toip;

static unsigned long userdport;


X2C_STACK_LIMIT(100000l)
extern int main(int argc, char **argv)
{
   X2C_BEGIN(&argc,argv,1,4000000l,8000000l);
   if (sizeof(RAWCALL)!=7) X2C_ASSERT(0);
   TimeConv_BEGIN();
   Lib_BEGIN();
   osi_BEGIN();
   Storage_BEGIN();
   Gencrctab();
   show = 0;
   touserport = 0UL;
   digisock = -1L;
   maxentries = 1000UL;
   lifetime = 604800UL;
   parms();
   if (digisock<0L) Err("need -u parameter", 18ul);
   users = 0;
   usersock = openudp();
   if ((touserport==0UL || usersock<0L) || bindudp(usersock, touserport)<0L) {
      Err("cannot bind userport (-p userport)", 35ul);
   }
   systime = TimeConv_time();
   for (;;) {
      fdclr();
      fdsetr((unsigned long)digisock);
      fdsetr((unsigned long)usersock);
      if (selectrw(10UL, 0UL)>0L) {
         if (issetr((unsigned long)digisock)) {
            /* data from digi */
            fromip = digiip;
            blen = getudp(digisock, ubuf, 338ul, &fromip, &userdport,
                checkdigiip);
            if (blen>=17L) {
               if (show) showframe("from digi ", 11ul, ubuf, 338ul);
               if (FindIp(&toip, &userdport, ubuf, 338ul)) {
                  res = udpsend(usersock, ubuf, blen, userdport, toip);
               }
               else if (show) osi_WrStrLn(" digi out user not found", 25ul);
            }
         }
         if (issetr((unsigned long)usersock)) {
            /* data from user */
            fromip = 0UL;
            blen = getudp(usersock, ubuf, 338ul, &fromip, &userdport, 0);
            if (blen>=17L) {
               if (show) {
                  showpip(fromip, touserport);
                  showframe(" from user ", 12ul, ubuf, 338ul);
               }
               AddIp(fromip, userdport, ubuf, 338ul);
               res = udpsend(digisock, ubuf, blen, todigiport, digiip);
            }
         }
      }
      else systime = TimeConv_time();
   }
   X2C_EXIT();
   return 0;
}

X2C_MAIN_DEFINITION
